# Aurora: a modern toolbox for impurity transport, neutrals and radiation modeling

Aurora is an expanding package to simulate heavy-ion transportm neutrals and radiation in magnetically-confined plasmas. It includes a 1.5D impurity transport forward model which inherits many of the methods from the historical STRAHL code and has been thoroughly benchmarked with it. It also offers routines to analyze neutral states of hydrogen isotopes, both from the edge of fusion plasmas and from neutral beam injection. Aurora's code is mostly written in Python 3 and Fortran 90. A Julia interface has also recently been added. The package enables radiation calculations using ADAS atomic rates, which can easily be applied to the output of Aurora's own forward model, or coupled with other 1D, 2D or 3D transport codes. 

Documentation is available at https://aurora-fusion.readthedocs.io.


# Development 

The code is developed and maintained by F. Sciortino (MIT-PSFC) in collaboration with T. Odstrcil (GA) and A. Cavallaro (MIT), with support from O. Linder (MPI-IPP), C. Johnson (U. Auburn), D. Stanczak (IPPLM) and S. Smith (GA). The STRAHL documentation provided by R.Dux (MPI-IPP) was extremely helpful to guide the initial development of Aurora.

New contributors are more than welcome! Please get in touch at sciortino-at-psfc.mit.edu or open a pull-request via Github. 

Generally, we would appreciate if you could work with us to merge your features back into the main Aurora distribution if there is any chance that the changes that you made could be useful to others. 

# Installation

[![PyPI version](https://badge.fury.io/py/aurorafusion.svg)](https://badge.fury.io/py/aurorafusion) [![Anaconda-Server Badge](https://anaconda.org/sciortino/aurorafusion/badges/version.svg)](https://anaconda.org/sciortino/aurorafusion) [![Anaconda-Server Badge](https://anaconda.org/sciortino/aurorafusion/badges/latest_release_date.svg)](https://anaconda.org/sciortino/aurorafusion)

Aurora can be installed from PyPI using
```
pip install aurorafusion
```
Add a `--user` flag to the command above if you don't have write-access to the default package directory on your system (i.e. if you don't have root permissions). 

Installing via conda is now also possible using
```
conda install -c sciortino aurorafusion 
```
Note that the conda installation does NOT currently install dependencies on `omfit-eqdsk`, which users may need to install via `pip` (see the [PyPI repo](https://pypi.org/project/omfit-eqdsk/)). 

To look at the code and contribute to the Aurora repository, it is recommended to install from source, by git-cloning the [Aurora repo](https://github.com/fsciortino/aurora) from Github. This will ensure that you can access the latest version of the tools. Make sure to use the `master` branch to use a stable, updated version. After git-cloning, users can make use of the `setup.py` file, e.g. using 
```
python setup.py -e .
```
or use the makefile in the package directory to build the Fortran code using 
```
make clean; make aurora
```
Note that the makefile will not install any of the dependencies, listed in the `requirements.txt` file in the main directory. You can use this file to quickly install dependencies within a Python virtual environment, or install each dependency one at a time.

Note that the Julia version of the code is not built by default. If you have Julia installed on your system, you can do  
```
make julia
```
from the main package directory. This will build a Julia `sysimage` to speed up access of Julia source code from Python, but it is not strictly necessary. See the documentation to read about interfacing Python3 and Julia. 



# License

The package is made open-source with the hope that this will speed up research on fusion energy and make further code development easier. However, we kindly ask that all users communicate to us their purposes, difficulties and successes with Aurora, so that we may support users as much as possible and grow the code further. 


# Citing Aurora

Please see the [User Agreement](https://github.com/fsciortino/Aurora/blob/master/USER_AGREEMENT.txt). 

Datafiles for sputtering yields as a function of
impact energy and angle.    

Available projectiles:
H, D, T, He, N, Ne, Ar
(only for self-sputtering): Be, C, W

Available targets:
Be, C, W

The tables are calculated with the Monte Carlo program
trvmcmom, which is vectorized version of trim.sp
determining also moments of distributions. The program
assumes a nearly flat surface, a statistically roughness
in the order of a monolayer is taken into account.
Well polished surfaces give a good agreement with the
calculated yields, but for rough surfaces the strong
angular dependence is reduced, leading to an increase
in the sputtering yield at normal incidence and a 
decrease around the sputtering maximum.

The files named [projectile]_[target].y contain the
calculated sputtering yield Y, defined as the mean
number of sputtered target atoms per unity of incident
projectile ions.

The files named [projectile]_[target].ye contain the
calculated sputtering energy yield Ye, defined in such
a way that the mean energy of sputtered atoms, for a
constant energy E0 of the incident ions, is
<E> = E0 * (Ye/Y).

The tables are arranged in such a way that rows give an
angular dependence of sputtering yields at a fixed energy
E0, and columns give an energy dependence at a fixed angle
of incidence. On top of the tables the values for the 
atomic numbers (Z) and the masses (m) of the projectile 
(index 1) and the target atoms (index 2) and the value for
the surface binding energy (Es) are given. Furthermore, the
number ne of incident energies and the number na of incident
angles at which the data are calculated are provided.

The files named [projectile]_[target]_fit.y contain the
coefficients derived fitting the calculated sputtering
yield data with the Bohdansky formula
Y(E0) = Q*Sn*(1-(Eth/E0)^(2/3))*(1-(Eth/E0))^2
where E0 is the projectile energy, and Q and Eth are
fitting parameters, contained in the tables for each
available value of the projectile incidence angle.
Sn is the nuclear stopping cross section, defined as
Sn = (0.5*log(1+1.2288*epsilon))/
     (epsilon+0.1728*sqrt(epsilon)+0.008*epsilon^0.1504)
epsilon is the reduced energy, defined as epsilon = E0/ETF,
where ETF = ((Z1*Z2*e^2)/(alpha_L))*((m1+m2)/(m2)) is the
Thomas-Fermi energy, in which Z1, Z2 are the nuclear charges,
and m1, m2 are the masses of the projectile and target atoms
respectively, and e is the electron charge. Finally, alpha_L,
defined as alpha_L = 0.4685*(Z1^(2/3)+Z2^(2/3))^(-1/2), in
angstrom, is the Lindhard screening length.

The original data are published in W. Eckstein, IPP-Report
9/117, Garching, March 1998.
The fits are produced by A. Zito, Garching, October 2022.
Status October 2022: many fits are actually not produced yet
(i.e. the coefficients are NaNs in the fit tables).

Datafiles for particle and energy reflection coefficients
as a function of impact energy and angle.    

Available projectiles:
H, D, T, He, N, Ne, Ar
(only for self-reflection): Be, C, W

Available targets:
Be, C, W

The tables are calculated with the Monte Carlo program
trvmcmom, which is vectorized version of trim.sp
determining also moments of distributions. The program
assumes a nearly flat surface, a statistically roughness
in the order of a monolayer is taken into account.
Well polished surfaces give a good agreement with the
calculated yields, but for rough surfaces the strong
angular dependence is reduced.

The files named [projectile]_[target].rn contain the
calculated particle reflection coefficient Rn, defined
as the fraction of incident projectile ions which are
backscattered from the surface.

The files named [projectile]_[target].re contain the
calculated energy reflection coefficient Re, defined
in such a way that the mean energy of backscattered
ions, for a constant energy E0 of the incident ions, is
<E> = E0 * (Re/Rn).

The tables are arranged in such a way that rows give an
angular dependence of reflection coefficients at a fixed
energy E0, and columns give an energy dependence at a fixed
angle of incidence. On top of the tables the values for the 
atomic numbers (Z) and the masses (m) of the projectile 
(index 1) and the target atoms (index 2) and the value for
the surface binding energy (Es) are given. Furthermore, the
number ne of incident energies and the number na of incident
angles at which the data are calculated are provided.

The files named [projectile]_[target]_fit.rn and 
[projectile]_[target]_fit.re contain, respectively, the
parameters derived fitting the calculated reflection
coefficients with the empirical Eckstein formula
Rn(E0) = (exp(a1*epsilon^a2))/(1+exp(a3*epsilon^a4)) and
Re(E0) = (exp(b1*epsilon^b2))/(1+exp(b3*epsilon^b4)),
where E0 is the projectile energy, and (a1,a2,a3,a4)
and (b1,b2,b3,b4) are the fitting parameters for particle
and energy reflection coefficients respectively, contained
in the tables for each available value of the projectile
incidence angle.
epsilon is the reduced energy, defined as epsilon = E0/ETF,
where ETF = ((Z1*Z2*e^2)/(alpha_L))*((m1+m2)/(m2)) is the
Thomas-Fermi energy, in which Z1, Z2 are the nuclear charges,
and m1, m2 are the masses of the projectile and target atoms
respectively, and e is the electron charge. Finally, alpha_L,
defined as alpha_L = 0.4685*(Z1^(2/3)+Z2^(2/3))^(-1/2), in
angstrom, is the Lindhard screening length.

The original data are published in W. Eckstein, IPP-Report
9/117, Garching, March 1998.
The fits are produced by A. Zito, Garching, October 2022.

Datafiles for sputtering yields of impurity atoms implanted
into bulk materials as a function of impact energy, angle
and concentration of impurity atoms into the surface material.
Please note that these data are pure result of Monte Carlo
calculation, and they have not been benchmarked yet against
experimental sputtering yields of impurities implanted in
different bulk materials by different projectiles.    

Available projectiles:
D, He, B, N

Available implanted impurities:
He

Available targets:
W

The tables are calculated with the Monte Carlo program
trim.sp. The program assumes a nearly flat surface, a
statistically roughness in the order of a monolayer is
taken into account. The program assumes the impurity atoms
being uniformly implanted into a layer of surface material
until a given depth, which is reported in the tables.
Additionally the impurity atoms are assumed to have no
surface binding energy to the bulk material, meaning that
they are released as thermal particles.

The files named [projectile]_[impurity]_[target].y contain
the calculated sputtering yield, defined as the mean
number of sputtered impurity atoms per unity of incident
projectile ions.
The tables are arranged in rows providing the sputtering
yield of the implanted impurity (Y_imp) in function of
angle of incidence of the projectile, energy of the
projectile and impurity concentration into the surface
layer of material (C_imp, defined as N_imp/(N_bulk+N_imp)).
On top of the tables the values for the  atomic numbers
(Z) and the masses (m) of the projectile  (index 1) and
the impurity target atoms (index 2) are given, as well
as the depth of the assumed implantation profile.

The files named [projectile]_[impurity]_[target]_fit.y
contain the coefficients derived fitting the calculated
sputtering yield data with the Bohdansky formula
Y(E0)/C_imp = Q*Sn*(1-(Eth/E0)^(2/3))*(1-(Eth/E0))^2
where E0 is the projectile energy, and Q and Eth are
fitting parameters, contained in the tables for each
available value of the projectile incidence angle.
Sn is the nuclear stopping cross section, defined as
Sn = (0.5*log(1+1.2288*epsilon))/
     (epsilon+0.1728*sqrt(epsilon)+0.008*epsilon^0.1504)
epsilon is the reduced energy, defined as epsilon = E0/ETF,
where ETF = ((Z1*Z2*e^2)/(alpha_L))*((m1+m2)/(m2)) is the
Thomas-Fermi energy, in which Z1, Z2 are the nuclear charges,
and m1, m2 are the masses of the projectile and target atoms
respectively, and e is the electron charge. Finally, alpha_L,
defined as alpha_L = 0.4685*(Z1^(2/3)+Z2^(2/3))^(-1/2), in
angstrom, is the Lindhard screening length.
The increase of the calculated sputtering yield with the
impurity concentration in the material is roughly linear,
meaning that one single fit, giving Y(E0)/C_imp, can be
indeed used.

The original data and the fits are produced by K. Schmid,
Garching, September 2022.

subroutine linip_arr(m, n, ts, ys, t, y)
!
!     Linear interpolation of time dependent profiles.
!     For times which are outside the bounds the profile is set to the last/first present time.
!
!     Note that this subroutine is different than the one in STRAHL's math.f (L194) because for transport coefficients
!     we don't care about whether a profile has previously been interpolated or not.
!
!     INPUTS:
!     m                       number of ts-vector elements
!     n                        number of used rho-vector elements
!     ts	                The time vector. Values MUST be monotonically increasing.
!     ys(rho, ts)          array of ordinate values.
!     t	                The time for which the ordinates shall be interpolated
!
!     OUTPUT:
!     y(rho)                 interpolated profiles at the chosen time
!
  IMPLICIT NONE

  INTEGER, INTENT(IN)                 :: m
  INTEGER, INTENT(IN)                 :: n
  REAL*8, INTENT(IN)                   :: ts(m)
  REAL*8, INTENT(IN)                   :: ys(n, m)

  REAL*8, INTENT(IN)                   :: t
  REAL*8, INTENT(OUT)                :: y(n)

  INTEGER :: k, i

  REAL*8 ::  ff

  ! if only one time point has been given, then return the same/only value
  if (m.eq.1) then
     do i=1,n
        y(i) = ys(i,1)
     enddo
     return
  endif

  ! if the requested time is greater than the maximum time provided, then use the last time
  if (t.ge.ts(m)) then
     do i=1,n
        y(i) = ys(i,m)
     enddo
     return
  endif

  ! if the requested time is smaller than the minimum time provided, then use the first time
  if (t.lt.ts(1)) then
     do i=1,n
        y(i) = ys(i,1)
     enddo
     return
  endif

  ! find time point in "ts" vector that is marginally larger than the requested "t"
  k=0
  do k=1,m+1
     if (t < ts(k+1)) then
        exit
     endif
  enddo

  ff = (t - ts(k))/(ts(k+1) - ts(k))
  do i=1,n
     y(i) = ys(i,k)*(1.0d0 - ff) + ys(i,k+1)*ff
  enddo

end subroutine linip_arr









subroutine asc_sort(n, a, index)
  ! sorts a in ascending order and gives the indices
  ! of the old vector for the new vector

  IMPLICIT NONE

  INTEGER, INTENT(IN)           :: n
  REAL*8, INTENT(INOUT)         :: a(n)
  INTEGER, INTENT(OUT)          :: index(n)

  REAL*8 ::  v
  INTEGER :: i,j,w

  do i=1,n
     index(i) = i
  enddo

  do j=2, n
     v = a(j)
     w = index(j)
     do i= j-1,  1, -1
        if (a(i) .le. v) goto 10
        a(i+1) = a(i)
        index(i+1) = index(i)
     enddo
     i = 0
10   a(i+1) = v
     index(i+1) = w
  enddo
  return
end subroutine asc_sort




subroutine chg_ord_r(n, a, index, wksp)
  ! changes order of real vector a according to index vector

  IMPLICIT NONE
  INTEGER, INTENT(IN)       :: n
  REAL*8, INTENT(INOUT)     :: a(n)
  INTEGER, INTENT(IN)       :: index(n)
  REAL*8, INTENT(OUT)       :: wksp(n)

  INTEGER :: i

  do i=1, n
     wksp(i) = a(index(i))
  enddo
  do i=1, n
     a(i) = wksp(i)
  enddo
  return
end subroutine chg_ord_r



subroutine chg_ord_i(n, a, index, wksp)
  ! changes order of integer vector a according to index vector

  IMPLICIT NONE
  INTEGER, INTENT(IN)    :: n
  INTEGER, INTENT(INOUT)     :: a(n)
  INTEGER, INTENT(IN)    :: index(n)
  INTEGER, INTENT(OUT)    :: wksp(n)

  INTEGER :: i

  do i=1, n
     wksp(i) = a(index(i))
  enddo
  do i=1, n
     a(i) = wksp(i)
  enddo
  return
end subroutine chg_ord_i

module aurora
@inline function run(nt_out, t_trans, D, V, par_loss_rates, src_rad_prof, S_rates,
             R_rates, rr, pro, qpr, r_saw, dlen, time, saw, flx, it_out, dsaw, rcl,
             divbls, taudiv, taupump, tauwret, rvol_lcfs, dbound, dlim, prox,
             rn, alg_opt, evolveneut)
    """
    !
    ! Run forward model of radial impurity transport, returning the density of
    ! each charge state over time and space.
    !
    ! ------ All inputs are in CGS units -----
    !
    ! Get list of required input parameters in Python using
    ! print(aurora.run.__doc__)
    !
    ! Args:
    !     nion         integer
    !                    Number of ionization stages. Not needed for Python calls.
    !     ir           integer
    !                    Number of radial grid points. Not needed for Python calls.
    !     nt           integer
    !                    Number of time steps for the solution. Not needed for Python calls.
    !     nt_out       integer
    !                    Number of times at which the impurity densities shall be saved.
    !     nt_trans     integer
    !                    Number of times at which D,V profiles are given. Not needed for Python calls.
    !     t_trans      real*8 (nt_trans)
    !                    Times at which transport coefficients change [s].
    !     D            real*8 (ir,nt_trans,nion)
    !                    Diffusion coefficient on time and radial grids [cm^2/s]
    !                    This must be given for each charge state and time.
    !     V            real*8 (ir,nt_trans,nion)
    !                    Drift velocity on time and radial grids [cm/s]
    !                    This must be given for each charge state and time.
    !     par_loss_rates  real*8 (ir,nt)
    !                    Frequency for parallel loss on radial and time grids [1/s]
    !     src_rad_prof real*8 (ir,nt)
    !                    Radial profile of neutrals over time: n0(ir,t) = flx*src_rad_prof(ir,t).
    !     S_rates      real*8 (ir,nion,nt)
    !                    Ionisation rates (nz=nion must be filled with zeros).
    !     R_rates      real*8 (ir,nion,nt)
    !                    Recombination rates (nz=nion must be filled with zeros)
    !     rr           real*8 (ir)
    !                    Radial grid, defined using normalized flux surface volumes
    !     pro          real*8 (ir)
    !                    Normalized first derivative of the radial grid, defined by
    !                    pro = (drho/dr)/(2 d_rho) = rho'/(2 d_rho)
    !     qpr          real*8 (ir)
    !                    Normalized second derivative of the radial grid, defined as
    !                    qpr = (d^2 rho/dr^2)/(2 d_rho) = rho''/(2 d_rho)
    !     r_saw        real*8
    !                    Sawteeth inversion radius [cm]
    !     dlen         real*8
    !                    Decay length at last radial grid point
    !     time         real*8 (nt)
    !                    Time grid for transport solver
    !     saw          integer (nt)
    !                    Switch to induce a sawtooth crashes
    !                    If saw(it) eq 1 there is a crash at time(it)
    !     flx          real*8 (nt)
    !                    Impurity influx per unit length and time [1/cm/s]
    !                    (only 1 to nt-1 are used)
    !     it_out       integer (nt)
    !                    Store the impurity distributions if it_out(it).eq.1
    !     dsaw         real*8
    !                    Width of sawtooth crash region.
    !     rcl          real*8
    !                    Wall recycling coefficient. Normally, this would be in the range [0,1].
    !                    However, if set to a value <0, then this is interpreted as a flag, indicating
    !                    that particles in the divertor should NEVER return to the main plasma.
    !     divbls       real*8
    !                    Fraction of the total flux (given by flx) that is directed to the divertor
    !                    reservoir. This value should be between 0 and 1.
    !     taudiv       real*8
    !                    Time scale for transport out of the divertor reservoir [s]
    !     taupump      real*8
    !                    Time scale for impurity elimination through out-pumping [s]
    !     tauwret      real*8
    !                    Time scale of temporary retention at the wall [s]
    !     rvol_lcfs    real*8
    !                    Radius (in rvol units, cm) at which the LCFS is located
    !     dbound       real*8
    !                    Width of the SOL, given by r_bound - r_lcfs (in rvol coordinates, cm)
    !                    This value sets the width of the radial grid.
    !     dlim         real*8
    !                    Position of the limiter wrt to the LCFS, i.e. r_lim - r_lcfs (cm, in r_vol units).
    !                    Inside of this limiter location, the parallel connection length to the divertor applies,
    !                    while outside of it the relevant connection length is the one to the limiter.
    !                    These different connection lengths must be taken into consideration when
    !                    preparing the parallel loss rate variable.
    !     prox         real*8
    !                    Grid parameter for loss rate at the last radial point, returned by
    !                    `get_radial_grid' subroutine.
    !     rn_t0        real*8 (ir,nion), optional
    !                    Impurity densities at the start time [1/cm^3]. If not provided, all elements are
    !                    set to 0.
    !     alg_opt      integer, optional
    !                    Integer to indicate algorithm to be used.
    !                    If set to 0, use the finite-differences algorithm used in the 2018 version of STRAHL.
    !                    If set to 1, use the Linder finite-volume algorithm (see Linder et al. NF 2020)
    !     evolneut     logical, optional
    !                    Boolean to activate evolution of neutrals (like any ionization stage)
    !
    ! Returns:
    !
    !     rn_out       real*8 (ir,nion,nt_out)
    !                    Impurity densities (temporarily) in the magnetically-confined plasma at the
    !                    requested times [1/cm^3].
    !     N_ret        real*8 (nt_out)
    !                    Impurity densities (permanently) retained at the wall over time [1/cm^3].
    !     N_wall       real*8 (nt_out)
    !                    Impurity densities (temporarily) at the wall over time [1/cm^3].
    !     N_div        real*8 (nt_out)
    !                    Impurity densities (temporarily) in the divertor reservoir over time [1/cm^3].
    !     N_pump       real*8 (nt_out)
    !                    Impurity densities (permanently) in the pump [1/cm^3].
    !     N_tsu        real*8 (nt_out)
    !                    Edge loss [1/cm^3].
    !     N_dsu        real*8 (nt_out)
    !                    Parallel loss [1/cm^3].
    !     N_dsul       real*8 (nt_out)
    !                    Parallel loss to limiter [1/cm^3].
    !     rcld_rate    real*8 (nt_out)
    !                    Recycling from divertor [1/cm^3/s].
    !     rclw_rate    real*8 (nt_out)
    !                    Recycling from wall [1/cm^3/s].
    ! ---------------------------------------------------------------------------

    """
    # Sizing info
    ir, nt_trans, nion = size(D)
    _, nt = size(par_loss_rates)

    # Intermediaries
    ra = Array{Float64,2}(undef, ir, nion)
    diff = Array{Float64,2}(undef, ir, nion)
    conv = Array{Float64,2}(undef, ir, nion)
    sext = Vector{Float64}(undef, ir)

    if alg_opt == 1
        # For use in impden_conserv!
        ntt = Vector{Float64}(undef, ir)
        a = Vector{Float64}(undef, ir)
        b = Vector{Float64}(undef, ir)
        c = Vector{Float64}(undef, ir)
        d = Vector{Float64}(undef, ir)
    else
        # For use in impden!
        a = Array{Float64,2}(undef, ir, nion)
        b = Array{Float64,2}(undef, ir, nion)
        c = Array{Float64,2}(undef, ir, nion)
        d1 = Vector{Float64}(undef, ir)
        bet = Vector{Float64}(undef, ir)
        gam = Vector{Float64}(undef, ir)
    end


    # Outputs
    rn_out = Array{Float64,3}(undef, ir, nion, nt_out)
    N_wall = Vector{Float64}(undef, nt_out)
    N_div = Vector{Float64}(undef, nt_out)
    N_pump = Vector{Float64}(undef, nt_out)
    N_ret = Vector{Float64}(undef, nt_out)
    N_tsu = Vector{Float64}(undef, nt_out)
    N_dsu = Vector{Float64}(undef, nt_out)
    N_dsul = Vector{Float64}(undef, nt_out)
    rcld_rate = Vector{Float64}(undef, nt_out)
    rclw_rate = Vector{Float64}(undef, nt_out)

    rcld = 0.
    rclw = 0.
    Nret = 0.
    tve = 0.
    divnew = 0.
    npump = 0.
    tsu = 0.
    dsu = 0.
    dsul = 0.

    it = 1
    kt = 1
    # Output if indicated
    @inbounds if it_out[it] == 1
        rn_out[:,:,kt] = rn

        N_wall[kt] = tve
        N_div[kt] = divnew
        N_pump[kt] = npump
        N_tsu[kt] = tsu
        N_dsu[kt] = dsu
        N_dsul[kt] = dsul

        N_ret[kt] = Nret
        rcld_rate[kt] = 0.
        rclw_rate[kt] = 0.
        kt += 1
    end

    # ============ time loop: ==========
    @inbounds for it in 2:nt
        dt = time[it] - time[it-1]

        ra .= rn # update old array to new (from previous time step)

        for nz in 1:nion
            # updated transport coefficients for each charge state
            linip_arr!(nt_trans, ir, t_trans, view(D, :, :, nz), time[it], view(diff, :, nz))
            linip_arr!(nt_trans, ir, t_trans, view(V, :, :, nz), time[it], view(conv, :, nz))
        end

        divold = divnew

        # pick current ioniz and recomb coeffs. || loss rate and source radial prof
        r_rates = view(R_rates,:,:,it)
        s_rates = view(S_rates,:,:,it)
        par_loss_rate = view(par_loss_rates,:,it)
        src_prof = view(src_rad_prof,:,it)

        # evolve impurity density with current transport coeffs
        if alg_opt == 1
            Nret, rcld, rclw = impden_conserv!(nion, ir, ra, rn, diff, conv,
                               par_loss_rate, src_prof, s_rates, r_rates, rr,
                               flx[it-1], dlen, dt, rcl, tsu, dsul, divold,
                               divbls, taudiv, tauwret, evolveneut, Nret, rcld,
                               rclw, ntt, a, b, c, d)
        else
            Nret, rcld, rclw = impden!(nion, ir, ra, rn, diff, conv, par_loss_rate, src_prof, s_rates, r_rates, rr,
                            pro, qpr, flx[it-1], dlen, dt, rcl, tsu, dsul, divold,
                            divbls, taudiv, tauwret, Nret, rcld, rclw, a, b, c, d1, bet, gam)
        end

        # sawteeth
        if saw[it] == 1
            saw_mix!(nion, ir, rn, r_saw, dsaw, rr, pro)
        end

        # particle losses at wall & divertor + recycling
        tve, divnew, npump, tsu, dsu, dsul = edge_model!(nion, ir, ra, rn, diff, conv, par_loss_rate, dt, rvol_lcfs,
                            dbound, dlim, prox, rr, pro, rcl, taudiv, taupump,
                            divbls, divold, flx[it-1], divnew, tve, npump, tsu,
                            dsu, dsul)

        # array time-step saving/output
        if it_out[it] == 1
            rn_out[:,:,kt] = rn

            N_wall[kt] = tve
            N_div[kt] = divnew
            N_pump[kt] = npump
            N_tsu[kt] = tsu
            N_dsu[kt] = dsu
            N_dsul[kt] = dsul

            N_ret[kt] = Nret
            rcld_rate[kt] = rcld
            rclw_rate[kt] = rclw
            kt += 1
        end
    end

    # End of time loop

    return rn_out, N_wall, N_div, N_pump, N_ret, N_tsu, N_dsu, N_dsul, rcld_rate, rclw_rate
end
@inline function impden_conserv!(nion, ir, ra, rn, diff, conv, par_loss_rate, src_prof, s_rates, r_rates, rr,
                flx, fall_outsol, det, rcl, tsuold, dsulold, divold, divbls, taudiv,
                tauwret, evolveneut, Nret, rcld, rclw, nt, a, b, c, d)
    #     **************************************************
    #     ** Time CENTERED TREATMENT in radial coordinate **
    #     ** LACKNER METHOD IN Z                          **
    #     ** time step is split in two half time steps    **
    #     **************************************************
    flxtot = flx*(1-divbls)
    dt = det/2.0

    # Recycling
    if rcl >= 0    # activated divertor return (R>=0) + recycling mode (if R>0)
        rcld = divold/taudiv
        rclw = rcl*(tsuold+dsulold)

        if tauwret > 0
          # include flux from particles previously retained at the wall
          Nret = Nret * (1-det/tauwret) + rclw*det     # number of particles temporarily retained at wall
          rclw = Nret/tauwret    # component that goes back to be a source
        end

        flx_rcl = rclw + rcld
    else   # no divertor return at all
        rcld = 0.0
        rclw = 0.0
        flx_rcl = 0.0
    end

    # Radial profile of recycling source should be close to the wall
    # Set it to be the same as the input (valve) source -- this may need revision:
    srcl = src_prof

    # select whether neutrals should be evolved
    ns = 2
    if evolveneut
        ns = 1
    end

    # ----- First half time step: direction up --------------------|
    # Externally provided neutrals
    if ns == 1
       impden_constTranspMatrix(view(ra,:,1), view(diff,:,1), view(conv,:,1), ir, dt, fall_outsol, par_loss_rate, rr, a, b, c, d)

       for i=1:ir
          b[i]    = b[i] + dt*s_rates[i,1]
          d[i]    = d[i] + dt*(flxtot*src_prof[i] + flx_rcl*srcl[i])
       end
       TDMA(a, b, c, d, ir, nt)
    else
       nt .= 0
       # radial profile of neutrals (given as input)
       for i=1:ir
           rn[i,1] = flxtot*src_prof[i] + flx_rcl* srcl[i]
       end
    end

    # Ions and recombined neutrals
    for nz=ns:nion
       # Construct transport matrix
       impden_constTranspMatrix(view(ra,:,nz), view(diff,:,nz), view(conv,:,nz), ir, dt, fall_outsol, par_loss_rate, rr, a, b, c, d)

       #Add ionization and recombination
       for i=1:ir
          b[i]    = b[i] + dt*s_rates[i,nz]
          if nz > 1
               d[i]    = d[i] + dt*(rn[i,nz-1]*s_rates[i,nz-1] - ra[i,nz]*r_rates[i,nz-1])
          end
          if nz < nion
               d[i]    = d[i] + dt*ra[i,nz+1]*r_rates[i,nz]
          end
          if nz == 2
               d[i]    = d[i] + dt*nt[i]*s_rates[i,1]
          end
       end

       # Solve tridiagonal system of equations
       TDMA(a, b, c, d, ir, view(rn,:,nz))
    end

    # ----- Second half time step: direction down -----------------|
    # Ions and recombined neutrals
    for nz=nion:-1:ns
       # Construct transport matrix
       impden_constTranspMatrix(view(rn,:,nz), view(diff,:,nz), view(conv,:,nz), ir, dt, fall_outsol, par_loss_rate, rr, a, b, c, d)

       # Add ionization and recombination
       for i=1:ir
          d[i]    = d[i] - dt*rn[i,nz]*s_rates[i,nz]
          if nz > 1
             b[i]    = b[i] + dt*r_rates[i,nz-1]
             d[i]    = d[i] + dt*rn[i,nz-1]*s_rates[i,nz-1]
          end
          if nz < nion
               d[i]    = d[i] + dt*rn[i,nz+1]*r_rates[i,nz]
          end
          if nz == 2
               d[i]    = d[i] + dt*nt[i]*s_rates[i,1]
          end
       end

       # Solve tridiagonal equation system
       TDMA(a, b, c, d, ir, view(rn,:,nz))
    end

    # Externally provided neutrals
    if ns == 1
       impden_constTranspMatrix(nt, view(diff,:,1), view(conv,:,1), ir, dt, fall_outsol, par_loss_rate, rr, a, b, c, d)

       for i=1:ir
          d[i]    = d[i] - dt*nt[i]*s_rates[i,1] + dt*(flxtot*src_prof[i] + flx_rcl* srcl[i])
       end
       TDMA(a, b, c, d, ir, view(rn,:,1))
    end

    return Nret, rcld, rclw
end

@inline function impden_constTranspMatrix(rnt, dimp, vimp, ir, dt, fall_outsol, par_loss_rate, rr, a, b, c, d)

    # Temporal component
    a .= 0.0
    b .= 1.0
    c .= 0.0
    d .= rnt

    # Central point (r = 0)
    # Enforces dn/dr|_r=0 = 0 and v(r=0) = 0


    # Geometric factors
    drp = rr[2] - rr[1]
    rp = 0.5*(rr[1] + rr[2])
    gi = 2.0/(rp^2)


    # Diffusion contribution
    Dp = 0.5*(dimp[1] + dimp[2])
    coefp = 0.5*dt*gi*rp*Dp/drp

    b[1] += coefp
    c[1] -= coefp
    d[1] += coefp*(rnt[2] - rnt[1])


    # adeection contribution
    vp = 0.5*(vimp[1]+vimp[2])
    kap = 0.0
    if abs(vp) > 2.0*Dp/drp
        kap = max(0.0, 1.0-2.0*Dp/(drp*abs(vp)))*sign(vp)
    end

    coefp = 0.25*dt*gi*rp*vp

    b[1] += coefp*(1 + kap)
    c[1] += coefp*(1 - kap)
    d[1] -= coefp*((1 + kap)*rnt[1] + (1 - kap)*rnt[2])

    # Interior points
    for i in 2:ir-1
        #! ----- Geometric factors -------------------------------------|
        drm     = drp
        drp     = rr[i+1]-rr[i]
        rm      = rp
        rp      = .5*(rr[i]+rr[i+1])
        gi      = 2.0/(rp^2-rm^2)

        #! ----- Diffusion contribution --------------------------------|
        Dm      = Dp
        Dp      = .5*(dimp[i]+dimp[i+1])
        coefm   = .5*dt*gi*rm*Dm/drm
        coefp   = .5*dt*gi*rp*Dp/drp

        a[i]    = a[i] - coefm
        b[i]    = b[i] + coefm + coefp
        c[i]    = c[i]         - coefp
        d[i]    = d[i] - coefm*(rnt[i] - rnt[i-1]) + coefp*(rnt[i+1] - rnt[i])

        #! ----- adeection contribution --------------------------------|
        vm      = vp
        vp      = .5*(vimp[i]+vimp[i+1])

        kam     = 0.
        if abs(vm) > 2.0*Dm/drm
           kam = sign(vm)*max(0, 1.0-2.0*Dm/(drm*abs(vm)))
        end
        kap     = 0.
        if abs(vp) > 2.0*Dp/drp
           kap = sign(vp)*max(0, 1.0-2.0*Dp/(drp*abs(vp)))
        end

        coefm   = .25*dt*gi*rm*vm
        coefp   = .25*dt*gi*rp*vp

        a[i]    = a[i] - coefm*(1+kam)
        b[i]    = b[i] - coefm*(1-kam) + coefp*(1+kap)
        c[i]    = c[i]                 + coefp*(1-kap)
        d[i]    = d[i] + coefm*((1+kam)*rnt[i-1] + (1-kam)*rnt[i])- coefp*((1+kap)*rnt[i] + (1-kap)*rnt[i+1])
    end

    # Outer point (r = r)

    # Geometric factors
    drm = drp
    rm = rp
    rp = rr[ir] + 0.5*drm
    gi = 2.0/(rp^2-rm^2)

    # Diffusion contribution
    Dm = Dp
    Dp = dimp[ir]
    coefm = 0.5*dt*gi*rm*Dm/drm
    coefp = 0.5*dt*gi*rp*Dp

    a[ir] -= coefm
    b[ir] += coefm
    d[ir] -= coefm*(rnt[ir] - rnt[ir-1])

    if fall_outsol > 0.0
        b[ir] += coefp/fall_outsol
        d[ir] -= coefp/fall_outsol*rnt[ir]
    end

    # adeection contribution
    vm = vp
    vp = max(0.0, vimp[ir])

    kam = 0.0
    if abs(vm) > 2.0*Dm/drm
        kam = max(0.0, 1.0-2.0*Dm/(drm*abs(vm)))*sign(vm)
    end
    kap = 0.0
    if abs(vp) > 2.0*Dp/drp
        kap = max(0.0, 1.0-2.0*Dp/(drp*abs(vp)))*sign(vp)
    end
    coefm = .25*dt*gi*rm*vm
    coefp = .25*dt*gi*rp*vp

    a[ir] -= coefm*(1+kam)
    b[ir] -= coefm*(1-kam)
    d[ir] += coefm*((1+kam)*rnt[ir-1] + (1-kam)*rnt[ir])

    if fall_outsol > 0
        b[ir] += coefp*(2-(1-kap)*drp/fall_outsol)
        d[ir] -= coefp*(2-(1-kap)*drp/fall_outsol)*rnt[ir]
    end

    # SOL LOSSES

    # Interior points
    for i in 2:ir-1
        coefm = 0.5*dt*par_loss_rate[i]
        b[i] += coefm
        d[i] -= coefm*rnt[i]
    end

    # Outer point (r = r)
    if fall_outsol > 0.0
        coefm   = .5*dt*par_loss_rate[ir]
        b[ir] += coefm
        d[ir] -= coefm*rnt[ir]
   end
end

@inline function TDMA(dLow, dMain, dUpp, rhs, n, sol)
    dMainP = similar(dMain)
    rhsP = similar(rhs)
    # Modify coefficients
    dMainP[1] = dMain[1]
    rhsP[1] = rhs[1]
    for i in 2:n
        dMainP[i] = dMain[i] - dLow[i]*dUpp[i-1]/dMainP[i-1]
        rhsP[i] = rhs[i] - dLow[i]*rhsP[i-1]/dMainP[i-1]
    end

    # Construct solution
    sol[n] = rhsP[n]/dMainP[n]
    for i in n-1:-1:1
        sol[i] = (rhsP[i] - dUpp[i]*sol[i+1])/dMainP[i]
    end
end
@inline function impden!(nion, ir, ra, rn, diff, conv, par_loss_rate, src_prof, s_rates, r_rates, rr, pro, qpr,
                flx, dlen, det, rcl, tsuold, dsulold, divold, divbls, taudiv,
                tauwret, Nret, rcld, rclw, a, b, c, d1, bet, gam)
    """

    """

    # dr near magnetic axis

    der = rr[2] - rr[1]

    #     **************************************************
    #     ** Time CENTERED TREATMENT in radial coordinate **
    #     ** LACKNER METHOD IN Z                          **
    #     ** time step is split in two half time steps    **
    #     **************************************************
    flxtot = flx

    # ------ Recycling ------  ! impden.f  L328-L345
    # Part of the particles that hit the wall are taken to be fully-stuck. Another part is only temporarily retained at the wall.
    # Particles FULLY STUCK to the wall will never leave, i.e. tve can only increase over time (see above).
    # Particles that are only temporarily retained at the wall (given by the recycling fraction) come back
    # (recycle) according to the tauwret time scale.

    if rcl >= 0. # activated divertor return (R>=0) + recycling mode (if R>0)
        rcld = divold/taudiv
        rclw = rcl*(tsuold+dsulold)

        if tauwret > 0.
            # include flux from particles previously retained at the wall
            Nret = Nret * (1 - det/tauwret) + rclw*det # number of particles temporarily retained at wall
            rclw = Nret/tauwret # component that goes back to be a source
        end

        flxtot = flx*(1-divbls) + rclw + rcld
    else # no divertor return at all
        rcld = 0.
        rclw = 0.
    end

    @inbounds for i in 1:ir
        rn[i,1] = flxtot*src_prof[i] # index of 1 stands for first ionization stage
    end

    dt = det/2.

    ########### First half time step direction up #########

    @inbounds for nz in 2:nion
        #   r = 0
        a[1,nz] = 0.
        c[1,nz] = -2.0*dt*diff[1,nz]*pro[1]
        b[1,nz] = 1.0 - c[1,nz] + 2.0*dt*conv[2,nz]/der
        d1[1] = ra[1,nz]*(2.0-b[1,nz])-ra[2,nz]*c[1,nz]

        #   r=r or at r+db respectively

        if dlen > 0.
            temp1 = 4.0*dt*pro[ir]^2*diff[ir,nz]
            temp2 = 0.5*dt*(qpr[ir]*diff[ir,nz]-pro[ir]*conv[ir,nz])
            temp3 = 0.5*dt*(par_loss_rate[ir] + conv[ir,nz]/rr[ir])
            temp4 = 1.0/pro[ir]/dlen

            a[ir,nz] = -temp1
            b[ir,nz] = 1.0+(1.0+0.5*temp4)*temp1 + temp4*temp2 + temp3
            c[ir,nz] = 0.
            d1[ir] = -ra[ir-1,nz]*a[ir,nz] + ra[ir,nz]*(2.0 - b[ir,nz])
            b[ir,nz] += dt*s_rates[ir,nz]
            d1[ir] -= dt*(ra[ir,nz]*r_rates[ir,nz-1] - rn[ir,nz-1]*s_rates[ir,nz-1])

            if nz < nion
                d1[ir] += dt*ra[ir,nz+1]*r_rates[ir,nz]
            end
        else # Edge Conditions for rn[ir]=0
            a[ir,nz] = 0
            b[ir,nz] = 1.
            c[ir,nz] = 0.
            d1[ir] = ra[ir,nz]
        end

        #   normal coefficients

        for i in 2:ir-1
            temp1 = dt*pro[i]^2
            temp2 = 4.0*temp1*diff[i,nz]
            temp3 = dt/2.0*(par_loss_rate[i] + pro[i]*(conv[i+1,nz] - conv[i-1, nz]) + conv[i,nz]/rr[i])
            a[i,nz] = (0.5*dt*qpr[i]*diff[i,nz] + temp1*(0.5*(diff[i+1,nz] -
                     diff[i-1,nz] - conv[i,nz]/pro[i]) - 2.0*diff[i,nz]))
            b[i,nz] = 1.0 + temp2 + temp3
            c[i,nz] = -temp2 - a[i,nz]
            d1[i] = -ra[i-1,nz]*a[i,nz] + ra[i,nz]*(2.0-b[i,nz]) - ra[i+1,nz]*c[i,nz]
        end

        for i in 1:ir-1
            b[i,nz] += dt*s_rates[i,nz]
            d1[i] -= dt*(ra[i,nz]*r_rates[i,nz-1] - rn[i,nz-1]*s_rates[i,nz-1]) # ra --> "alt" (i-1) density; rnz --> "current" [i] density

            if nz < nion
                d1[i] += dt*ra[i,nz+1]*r_rates[i,nz] # al --> recomb; s --> ioniz
            end
        end

        #       solution of tridiagonal equation system
        bet[1] = b[1,nz]
        gam[1] = d1[1]/b[1,nz]
        for i in 2:ir
            bet[i] = b[i,nz] - (a[i,nz]*c[i-1,nz])/bet[i-1]
            gam[i] = (d1[i] - a[i,nz]*gam[i-1])/bet[i]
        end
        rn[ir,nz] = gam[ir]

        for i in ir-1:-1:1
            rn[i,nz] = gam[i] - (c[i,nz]*rn[i+1,nz])/bet[i]
        end
    end

    ########### Second half time step direction down #########

    @inbounds for nz in nion:-1:2
        #   r = 0
        a[1,nz] = 0.
        c[1,nz] = -2.0*dt*diff[1,nz]*pro[1]
        b[1,nz] = 1.0 - c[1,nz] + 2.0*dt*conv[2,nz]/der
        d1[1] = rn[1,nz]*(2.0 - b[1,nz]) - rn[2,nz]*c[1,nz]

        #       r=r or at r+db respectively

        if dlen > 0.
            temp1 = 4.0*dt*pro[ir]^2*diff[ir,nz]
            temp2 = 0.5*dt*(qpr[ir]*diff[ir,nz] - pro[ir]*conv[ir,nz])
            temp3 = 0.5*dt*(par_loss_rate[ir] + conv[ir,nz]/rr[ir])
            temp4 = 1.0/pro[ir]/dlen

            a[ir,nz] = -temp1
            b[ir,nz] = 1.0 + (1.0 + 0.5*temp4)*temp1 + temp4*temp2 + temp3
            c[ir,nz] = 0.
            d1[ir] = -rn[ir-1,nz]*a[ir,nz] + rn[ir,nz]*(2.0 - b[ir,nz])
            b[ir,nz] += dt*r_rates[ir,nz-1]
            d1[ir] -= dt*(rn[ir,nz]*s_rates[ir,nz] - rn[ir,nz-1]*s_rates[ir,nz-1])

            if nz < nion
                d1[ir] += dt*rn[ir,nz+1]*r_rates[ir,nz]
            end
        else # Edge conditions for rn[ir]=0.
            a[ir,nz] = 0
            b[ir,nz] = 1.
            c[ir,nz] = 0.
            d1[ir] = rn[ir,nz]
        end

        #       normal coefficients

        for i in 2:ir-1
            temp1 = dt*pro[i]^2
            temp2 = 4.0*temp1*diff[i,nz]
            temp3 = dt/2.0*(par_loss_rate[i] + pro[i]*(conv[i+1,nz] - conv[i-1,nz]) + conv[i,nz]/rr[i])

            a[i,nz] = (0.5*dt*qpr[i]*diff[i,nz] + temp1*(0.5*(diff[i+1,nz]-
                      diff[i-1,nz] - conv[i,nz]/pro[i]) - 2.0*diff[i,nz]))
            b[i,nz] = 1.0 + temp2 + temp3
            c[i,nz] = -temp2 - a[i,nz]
            d1[i] = -rn[i-1,nz]*a[i,nz] + rn[i,nz]*(2.0 - b[i,nz]) - rn[i+1,nz]*c[i,nz]
        end

        for i in 1:ir-1
            b[i,nz] += dt*r_rates[i,nz-1]
            d1[i] -= dt*(rn[i,nz]*s_rates[i,nz] - rn[i,nz-1]*s_rates[i,nz-1])

            if nz < nion
                d1[i] += dt*rn[i,nz+1]*r_rates[i,nz]*(nz < nion)
            end
        end

        #   solution of tridiagonal equation system

        bet[1] = b[1,nz]
        gam[1] = d1[1]/b[1,nz]
        for i in 2:ir
            bet[i] = b[i,nz] - (a[i,nz]*c[i-1,nz])/bet[i-1]
            gam[i] = (d1[i] - a[i,nz]*gam[i-1])/bet[i]
        end
        rn[ir,nz] = gam[ir]

        for i in ir-1:-1:1
            rn[i,nz] = gam[i] - (c[i,nz]*rn[i+1,nz])/bet[i]
        end
    end
    return Nret, rcld, rclw
end

@inline function saw_mix!(nion, ir, rn, rsaw, dsaw, rr, pro)
    """

    """
    #   index of mixing radius
    @inbounds for imix in 1:ir
        if rr[i] > rsaw

        end
    end

    @inbounds for nz in 2:nion    # loop over ionized stages

        #   area integral in mixing radius of old profile

        sum_old = (0.125*(rn[imix,nz]*rr[imix]/pro[imix] -
                   rn[imix-1,nz]*rr[imix-1]/pro[imix-1])) # only use new density, rn
        for i in 2:imix-1
            sum_old += rn[i,nz]*rr[i]/pro[i]
        end

        #   ERFC sawtooth crash model
        ff = sum_old/rr[imix]^2 # nmean
        for i in 1:ir
            rn[i,nz] = (ff/2.0*erfc((rr[i] - rsaw)/dsaw) + (rn[i,nz]/2.0)*
                        erfc(-(rr[i]-rsaw)/dsaw))
        end

        #      flat profile
        #  ff = sum_old/rr(imix)**2
        #  do i=1,imix-1
        #    rn[i,nz] = ff
        #  end do
        #  rn(imix,nz) = (ra(imix+1,nz)+ff)/2.

        #      area integral in mixing radius of new profile
        sum = (0.125*(rn[imix,nz]*rr[imix]/pro[imix] -
               rn[imix-1,nz]*rr[imix-1]/pro[imix-1]))
        for i in 2:imix-1
            sum += rn[i,nz]*rr[i]/pro[i]
        end

        #   ensure particle conservation

        ff = sum_old/sum
        for i in 1:imix
            rn[i,nz] = rn[i,nz]*ff
        end
    end
end

@inline function edge_model!(nion, ir, ra, rn, diff, conv, par_loss_rate, det, rvol_lcfs, dbound,
                    dlim, prox, rr, pro, rcl, taudiv, taupump, divbls, divold,
                    flx, divnew, tve, npump, tsu, dsu, dsul)
    """

    """

    ids = 0
    idl = 0
    rx = rvol_lcfs + dbound     # wall (final) location

    # --------------------------------
    # from plad.f
    @inbounds for i in 2:ir
        if rr[i] <= rvol_lcfs
            ids = i + 1 # number of radial points inside of LCFS
        end
        if rr[i] <= (rvol_lcfs + dlim)
            idl = i + 1 # number of radial points inside of limiter
        end
    end

    # ---------------------------------------
    # ions lost at periphery (not parallel)
    tsu = 0.
    @inbounds for nz in 2:nion
        tsu -= (prox*(diff[ir-1,nz] + diff[ir,nz])*(rn[ir,nz] + ra[ir,nz] -
                rn[ir-1,nz] - ra[ir-1,nz]) + 0.5*(conv[ir-1,nz] + conv[ir,nz])*
                (rn[ir,nz] + ra[ir,nz] + rn[ir-1,nz] + ra[ir-1,nz]))
    end
    tsu = tsu*0.5*pi*rx

    # parallel losses / second

    dsu = 0.
    dsul = 0.

    @inbounds for nz in 2:nion
        for i in ids:idl-1
            dsu += (ra[i,nz] + rn[i,nz])*par_loss_rate[i]*rr[i]/pro[i]
        end
        for i in idl:ir-1
            dsul += (ra[i,nz] + rn[i,nz])*par_loss_rate[i]*rr[i]/pro[i]
        end
    end
    dsu = dsu*pi/2. # to divertor
    dsul = dsul*pi/2.   # to limiter

    # time integrated losses at wall/limiters
    tve += (dsul + tsu)*(1.0 - max(0, rcl))*det

    # particles in divertor
    # If recycling is on, particles from limiter and wall come back.
    # Particles in divertor can only return (with rate given by N_div/taudiv) if rcl>=0
    if rcl >= 0 # activated divertor return (rcl>=0) + recycling mode (if rcl>0)
        taustar = 1.0/(1.0/taudiv + 1.0/taupump)
        ff = 0.5*det/taustar
        divnew = (divold*(1.0-ff) + (dsu + flx*divbls)*det)/(1.0+ff)    # FS corrected
    else
        divnew = divold + (dsu + flx*divbls)*det
    end

    # particles in pump
    npump += 0.5*(divnew + divold)/taupump*det
    return tve, divnew, npump, tsu, dsu, dsul
end


@inline function linip_arr!(m, n, ts, ys, t, y)
    """
    !
    !     Linear interpolation of time dependent profiles.
    !     For times which are outside the bounds the profile is set to the last/first present time.
    !

    !
    !     INPUTS:
    !     m                       number of ts-vector elements
    !     n                        number of used rho-vector elements
    !     ts	                The time vector. Values MUST be monotonically increasing.
    !     ys(rho, ts)          array of ordinate values.
    !     t	                The time for which the ordinates shall be interpolated
    !
    !     OUTPUT:
    !     y(rho)                 interpolated profiles at the chosen time
    !

    """

    #if only one time point has been given, then return the same/only value
    #or if the requested time is greater than the maximum time provided, then use the last time
     @inbounds if m == 1 || t >= ts[m]
        for i in 1:n
           y[i] = ys[i,m]
        end
        return
     end

     #if the requested time is smaller than the minimum time provided, then use the first time
     @inbounds if t < ts[1]
        for i in 1:n
           y[i] = ys[i,1]
        end
        return
     end

     #find time point in "ts" vector that is marginally larger than the requested "t"
     @inbounds for k in 1:m+1
        if (t < ts[k+1])

        end
     end

     ff = (t - ts[k])/(ts[k+1] - ts[k])
     @inbounds for i in 1:n
        y[i] = ys[i,k]*(1.0 - ff) + ys[i,k+1]*ff
     end
end
end

 subroutine get_radial_grid( &
     ir, dbound, k, dr_0, dr_1, rvol_lcfs, &
     rr, pro, prox, qpr)
   !
   !  Subroutine to produce radial grid as in STRAHL (see plad.f)
   !  NB: output grid arrays will be padded with zeros at the end.
   !
   ! NOTE: this function isn't needed anymore, since create_radial_grid in grids_utils.py
   ! now does the same thing in Python. This subroutine will be deleted soon!
   !

   IMPLICIT NONE

   INTEGER, INTENT(INOUT)                 :: ir  ! number of grid points  -- only used if dr_0<0
   REAL*8, INTENT(IN)                     :: dbound ! from param file

   REAL*8, INTENT(IN)                     :: k
   REAL*8, INTENT(IN)                     :: dr_0 ! from param file
   REAL*8, INTENT(IN)                     :: dr_1 ! from param file
   REAL*8, INTENT(IN)                     :: rvol_lcfs

   REAL*8, INTENT(OUT)                    :: rr(1000)   ! hard-coded max number of elements
   REAL*8, INTENT(OUT)                    :: pro(1000)  ! hard-coded max number of elements
   REAL*8, INTENT(OUT)                    :: prox
   REAL*8, INTENT(OUT)                    :: qpr(1000)  ! hard-coded max number of elements

   REAL*8 :: dro, rx, temp1, temp2, temp3
   integer :: i, j
   REAL*8 :: rrx(1000), ro(1000) ! hard-coded max number of elements
   REAL*8 :: a0,a1, der

   rx=rvol_lcfs+dbound

   ! Option #1
   if (dr_0.le.0.d0) then
      dro=(rx**k)/(float(ir)-1.5)
      der=dro**(1./k)

      do i=1,ir
         ro(i)=(i-1)*dro
         rr(i)=ro(i)**(1./k)
         rrx(i)=rr(i)/rvol_lcfs
      enddo

      ! terms related with derivatives of rho
      temp1 = .5/dro
      pro(1)=2./der**2
      do i=2,ir
         pro(i)=temp1*k*rr(i)**(k-1.)
         qpr(i)=k*pro(i)/rr(i)
      enddo
      prox = k*rx**(k-1.)/dro
   endif

   ! Option #2
   if (dr_0.gt.0.d0) then
      der = dr_0
      dro = 1.d0
      a0=1./dr_0
      a1=1./dr_1
      ir=nint(1.5+rx*(a0*k+a1)/(k+1.))

      a1=(k+1.)*(float(ir)-1.5)/rx-a0*k

      ! radius
      rr(1)=0.
      do i=2,ir
         temp1=0.d0
         temp2=rx*1.05
         ro(i) = (i-1)*dro
         do j=1,50
            rr(i) = (temp1+temp2)/2.
            temp3 = a0*rr(i)+(a1-a0)*rx/(k+1.)*(rr(i)/rx)**(k+1.)
            if (temp3.ge.ro(i)) then
               temp2=rr(i)
            else
               temp1=rr(i)
            endif
         enddo
         rrx(i)=rr(i)/rvol_lcfs
      enddo

      ! terms related with derivatives of rho
      temp1=.5/dro
      pro(1)=2./der**2
      do i=2,ir
         pro(i)=(a0+(a1-a0)*(rr(i)/rx)**k)*temp1
         qpr(i)=pro(i)/rr(i)+temp1*(a1-a0)*k/rx*(rr(i)/rx)**(k-1.)
      enddo
      prox = a1/dro
   endif

   return
 end subroutine get_radial_grid






 
subroutine time_steps(n, t, dtstart, itz, tinc, verbose, t_vals, i_save)
  !
  ! Define time base for Aurora based on user inputs
  ! This function reproduces the functionality of STRAHL's time_steps.f
  ! Refer to the STRAHL manual for definitions of the time grid
  !
  ! INPUTS:
  ! n             :      number of elements in time definition arrays
  ! t(n)          :      time vector of the time base changes
  ! dtstart(n)    :      dt value at the start of a cycle
  ! itz(n)        :      cycle length, i.e. number of time steps before increasing dt
  ! tinc(n)       :      factor by which time steps should be increasing within a cycle
  !
  ! OPTIONAL:
  ! verbose       :      print to terminal a few extra info
  !
  ! OUTPUTS:
  ! t_vals          :      time base
  !
  IMPLICIT NONE

  INTEGER, INTENT(IN)            :: n
  REAL*8, INTENT(IN)             :: t(n)
  REAL*8, INTENT(IN)             :: dtstart(n)
  INTEGER, INTENT(IN)            :: itz(n)
  REAL*8, INTENT(IN)             :: tinc(n)
  LOGICAL, INTENT(IN), OPTIONAL  :: verbose

  REAL*8, INTENT(OUT)            :: t_vals(30000)   ! hard-coded max size! Seg-fault if exceeded
  INTEGER, INTENT(OUT)           :: i_save(30000)   ! hard-coded max size! Seg-fault if exceeded

  INTEGER :: nsteps
  REAL*8 :: dt(250),ncyctot(250)   ! hard-coded max number of changes to 250

  REAL*8 ::  f ,wksp_r(n), det, tnew
  INTEGER :: i, ncyc(250), nevent, wksp_i(n), index(n), m , n_itz, nn
  LOGICAL :: verb

  ! arrays wihtout double time points
  REAL*8 :: t_s(250), dtstart_s(250), tinc_s(250)
  INTEGER:: itz_s(250)

  if(present(verbose))then
     verb=verbose
  else
     verb=.false.
  endif

  ! sort t-change and related verctors
  call asc_sort(n, t, index)
  call chg_ord_r(n, dtstart, index, wksp_r) ! modifies in place
  call chg_ord_r(n, tinc, index, wksp_r)    ! modifies in place
  call chg_ord_i(n, itz, index, wksp_i)     ! modifies in place

  if (verb) then
     write(*,*) 'Inputs after sorting::'
     write(*,*) 't:',t
     write(*,*) 'dtstart: ', dtstart
     write(*,*) 'tinc: ', tinc
     write(*,*) 'itz: ', itz
  endif

  ! cancel double time points
  nevent = 1
  t_s(1) = t(1)
  dtstart_s(1) = dtstart(1)
  tinc_s(1) = tinc(1)
  itz_s(1) = itz(1)
  do i= 2, n
     if ( abs(t(i)-t(nevent)) .gt. 1.e-8) then
        nevent = nevent + 1
        t_s(nevent) = t(i)
        dtstart_s(nevent) = dtstart(i)
        tinc_s(nevent) = tinc(i)
        itz_s(nevent) = itz(i)
     endif
  enddo

  ! define # of cycles for every interval with a start time step: dtstart(i)

  do i=1, nevent-1
     f = (t_s(i+1) - t_s(i))/dtstart_s(i)
     if (i.eq.1) f = f + 1.
     if (tinc_s(i).gt.1.) then
        ncyc(i) = max(2,nint(log(f/itz_s(i)*(tinc_s(i)-1.)+1.)/log(tinc_s(i))))
     endif
     if (tinc_s(i).eq.1.) then
        ncyc(i) = max(2,nint(f/itz_s(i)))
     endif

     if (i.eq.1) ncyctot(i) = ncyc(i)
     if (i.gt.1) ncyctot(i) = ncyctot(i-1) + ncyc(i)
  enddo

  ! sum of all timesteps
  nsteps = 0
  do i= 1, nevent-1
     nsteps = nsteps + ncyc(i) * itz_s(i)
  enddo
  nsteps = nsteps - 1

  ! define real start timestep dt(i) to fit the time intervals
  do i=1, nevent-1
     if (tinc_s(i).gt.1.) then
        f = itz_s(i)* (tinc_s(i)**ncyc(i)-1.)/(tinc_s(i)-1.)
     endif
     if (tinc_s(i).eq.1.) f = 1. * itz_s(i) * ncyc(i)
     if (i.eq.1) f = f - 1.
     dt(i) = (t_s(i+1) - t_s(i))/f
  enddo

  ! Now, define t list
  nn = 1
  n_itz = 1
  m = 1
  tnew = t_s(1)
  nevent=1
  det = dt(1)

  if (verb) then
     write(*,*) 'time_steps:'
     write(*,*) 'nsteps:',nsteps
     do i=1, nevent-1
        write(*,*) 'Interval:',i,' start step: ',dt(i)
     enddo
  endif

  t_vals(1) = tnew
  i_save(1) = 1

100 tnew = tnew + det
  t_vals(nn+1) = tnew

  if (mod(n_itz+1,itz_s(nevent)) .ne. 0) then
     nn = nn+1
     n_itz = n_itz + 1
     goto 100
  endif
  n_itz = 0
  det = tinc(nevent) * det
  if (m .eq. ncyctot(nevent) .and. nn.ne.nsteps) then
     nevent = nevent + 1
     det = dt(nevent)
  endif
  m=m+1
  i_save(nn+1) = 1

  if (nn.lt.nsteps) then
     nn = nn + 1
     goto 100
  endif

  return
end subroutine time_steps

!MIT License
!
!Copyright (c) 2021 Francesco Sciortino
!
!Extended recycling model and full plasma-wall interaction model
!provided by Antonello Zito
!
!Permission is hereby granted, free of charge, to any person obtaining a copy
!of this software and associated documentation files (the "Software"), to deal
!in the Software without restriction, including without limitation the rights
!to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
!copies of the Software, and to permit persons to whom the Software is
!furnished to do so, subject to the following conditions:
!
!The above copyright notice and this permission notice shall be included in all
!copies or substantial portions of the Software.
!
!THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
!IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
!FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
!AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
!LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
!OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
!SOFTWARE.

! Subroutines to forward model impurity transport. 
!
! impden0 uses the standard finite-difference scheme used in STRAHL.
! impden1 uses the finite-volumes scheme described in Linder NF 2020. 
!

subroutine impden0(nion, ir, species, ra, rn, diff, conv, par_loss_rate, &
     src_prof, rcl_rad_prof, rfl_rad_prof, spt_rad_prof, en_rec_neut, s_rates, r_rates,  &
     Raxis, rr, pro, qpr, dlen, det,  &    ! renaming dt-->det. In this subroutine, dt is half-step
     surfmain, surfdiv, PWI, Zmain, Zdiv, &
     rnmain, rndiv, fluxmain, fluxdiv, ymain, ydiv, depthmain, depthdiv, nmainsat, ndivsat, & 
     rcl,screen,rcmb,tsuold,dsuold,dsulold, divold, pumpold, taudiv, tauwret, leak, volpump, &
     a, b, c, d1, bet, gam, &
     Nmainret, Ndivret, rcld, rcld_refl, rcld_recl, div_flux_impl, div_fluxes_sput, &
     rclb, rcls, rclp, rclw, rclw_refl, rclw_recl, main_flux_impl, main_fluxes_sput)
     
  !
  !  Impurity transport forward modeling with default STRAHL finite-differences scheme.
  !  Refer to STRAHL manual 2018 for details of the algorithm.
  !  The recycling/pumping model, including the interaction between plasma and physical walls
  !  and the transport between the 0D neutrals reservoirs, has been widely extended wrt STRAHL,
  !  featuring a more realistic plasma-wall interaction model and a larger number of reservoirs.
  !
  ! ----------------------------------------------------------------------|

  IMPLICIT NONE

  INTEGER, INTENT(IN)       :: nion
  INTEGER, INTENT(IN)       :: ir
  INTEGER, INTENT(IN)       :: species
  REAL*8, INTENT(IN)        :: ra(ir,nion)   ! alt = old
  REAL*8, INTENT(OUT)       :: rn(ir,nion)   ! neu = new
  REAL*8, INTENT(IN)        :: diff(ir, nion)
  REAL*8, INTENT(IN)        :: conv(ir, nion)
  REAL*8, INTENT(IN)        :: par_loss_rate(ir)
  REAL*8, INTENT(IN)        :: src_prof(ir)
  REAL*8, INTENT(IN)        :: rcl_rad_prof(ir)
  REAL*8, INTENT(IN)        :: rfl_rad_prof(ir)
  REAL*8, INTENT(IN)        :: spt_rad_prof(ir,1+species)
  LOGICAL, INTENT(IN)       :: en_rec_neut
  REAL*8, INTENT(IN)        :: s_rates(ir,nion)
  REAL*8, INTENT(IN)        :: r_rates(ir,nion)
  REAL*8, INTENT(IN)        :: Raxis
  REAL*8, INTENT(IN)        :: rr(ir)
  REAL*8, INTENT(IN)        :: pro(ir)
  REAL*8, INTENT(IN)        :: qpr(ir)
  REAL*8, INTENT(IN)        :: dlen ! decay length at last radial grid point
  REAL*8, INTENT(IN)        :: det   ! full time step, named dt in subroutine `run'

  ! plasma-wall interaction inputs
  REAL*8, INTENT(IN)        :: surfmain
  REAL*8, INTENT(IN)        :: surfdiv
  LOGICAL, INTENT(IN)       :: PWI
  INTEGER, INTENT(IN)       :: Zmain
  INTEGER, INTENT(IN)       :: Zdiv
  REAL*8, INTENT(IN)        :: rnmain
  REAL*8, INTENT(IN)        :: rndiv
  REAL*8, INTENT(IN)        :: fluxmain(species)
  REAL*8, INTENT(IN)        :: fluxdiv(species)
  REAL*8, INTENT(IN)        :: ymain(1+species)
  REAL*8, INTENT(IN)        :: ydiv(1+species)
  REAL*8, INTENT(IN)        :: depthmain
  REAL*8, INTENT(IN)        :: depthdiv
  REAL*8, INTENT(IN)        :: nmainsat
  REAL*8, INTENT(IN)        :: ndivsat

  ! recycling inputs
  REAL*8, INTENT(IN)        :: rcl
  REAL*8, INTENT(IN)        :: screen
  REAL*8, INTENT(IN)        :: rcmb
  REAL*8, INTENT(INOUT)     :: tsuold   ! tsu from previous recycling step
  REAL*8, INTENT(INOUT)     :: dsuold   ! tsu from previous recycling step
  REAL*8, INTENT(INOUT)     :: dsulold  ! dsul from previous recycling step
  REAL*8, INTENT(IN)        :: divold   ! divnew from previous step (even without backflow)
  REAL*8, INTENT(IN)        :: pumpold  ! pumpnew from previous step (even without leakage)

  REAL*8, INTENT(IN)        :: taudiv
  REAL*8, INTENT(IN)        :: tauwret
  REAL*8, INTENT(IN)        :: leak
  REAL*8, INTENT(IN)        :: volpump

  ! Re-use memory allocation
  REAL*8, INTENT(INOUT)     :: a(ir,nion), b(ir,nion), c(ir,nion), d1(ir), bet(ir), gam(ir)

  REAL*8, INTENT(INOUT)     :: Nmainret
  REAL*8, INTENT(INOUT)     :: Ndivret
  REAL*8, INTENT(OUT)       :: rcld
  REAL*8, INTENT(OUT)       :: rcld_refl
  REAL*8, INTENT(OUT)       :: rcld_recl
  REAL*8, INTENT(OUT)       :: div_flux_impl
  REAL*8, INTENT(OUT)       :: div_fluxes_sput(1+species)
  REAL*8, INTENT(OUT)       :: rclb
  REAL*8, INTENT(OUT)       :: rcls
  REAL*8, INTENT(OUT)       :: rclp
  REAL*8, INTENT(OUT)       :: rclw
  REAL*8, INTENT(OUT)       :: rclw_refl
  REAL*8, INTENT(OUT)       :: rclw_recl
  REAL*8, INTENT(OUT)       :: main_flux_impl
  REAL*8, INTENT(OUT)       :: main_fluxes_sput(1+species)
  
  REAL*8 :: tauleak
  REAL*8 :: der
  INTEGER :: i, nz, s

  REAL*8 temp1, temp2, temp3, temp4, dt

  ! dr near magnetic axis
  der = rr(2) - rr(1)

  !     **************************************************
  !     ** Time CENTERED TREATMENT in radial coordinate **
  !     ** LACKNER METHOD IN Z                          **
  !     ** time step is split in two half time steps    **
  !     **************************************************
  
  ! Plasma-wall interaction
  
  if (PWI) then   ! full plasma-wall interaction model: wall content and fluxes determined by reflection, sputtering and wall saturation level
  
     if (rcl.ge.0) then
        rcls = (divold/taudiv)*(screen)
     else
        rcls = 0.d0
     endif
     
     call advanced_PWI_model(det, Raxis, tsuold, dsulold, dsuold, rcls, species, &
          rcmb, surfmain, surfdiv, Zmain, Zdiv, depthmain, depthdiv, nmainsat, ndivsat, &
          fluxmain, fluxdiv, rnmain, rndiv, ymain, ydiv, &
          Nmainret, Ndivret, &
          rclw, rclw_refl, rclw_recl, main_flux_impl, main_fluxes_sput, &
          rcld, rcld_refl, rcld_recl, div_flux_impl, div_fluxes_sput)
  
  else   ! simple plasma-wall interaction model: wall content and fluxes determined by simple recl. coeff. and retention time
  
     if (rcl.ge.0) then   ! recycling activated --> fluxes rclw, rcld present
  
        rclw = rcl*(tsuold+dsulold)   ! OLD flux towards main wall which can be recycled
        rcld = rcl*(1.-rcmb)*(dsuold+rcls)   ! OLD flux towards divertor wall which can be recycled
     
        if (tauwret.gt.0.0d0) then
           ! include flux from particles previously retained at the main wall
           Nmainret = Nmainret * (1-det/tauwret) + rclw*det   ! number of particles temporarily retained at main wall
           Ndivret = Ndivret * (1-det/tauwret) + rcld*det     ! number of particles temporarily retained at divertor wall
           rclw = Nmainret/tauwret   ! total recycled flux from main wall which will be a NEW source for the core plasma
           rcld = Ndivret/tauwret   ! total recycled flux from divertor wall which will be a NEW source for the divertor neutrals reservoir
        
        endif
     
     else   ! recycling de-activated --> no fluxes rclw, rcld, and temporary wall reservoirs are not filled
  
        rcld = 0.d0
        rclw = 0.d0
 
     endif
     
     rclw_refl = 0.d0
     rcld_refl = 0.d0
     rclw_recl = 0.d0
     rcld_recl = 0.d0
     main_flux_impl = 0.d0
     div_flux_impl = 0.d0
     do s = 1,1+species
        main_fluxes_sput(s) = 0.d0
        div_fluxes_sput(s) = 0.d0
     enddo
  
  endif
  
  ! Backflow from divertor
  
  if (rcl.ge.0) then   ! activated divertor/pump return --> fluxes rclb, rcls, rclp present
  
     rclb = (divold/taudiv)*(1-screen) ! non-screened backflow from previous time step
     rcls = (divold/taudiv)*(screen) ! screened backflow from previous time step
     if (leak.gt.0) then    ! pump reservoir present and activated leakage
        tauleak = volpump/leak
        rclp = pumpold/tauleak
     else
        rclp = 0.d0
     endif
     
  else   ! no divertor/pump return --> no fluxes rclb, rcls, rclp at all
  
     rclb = 0.d0
     rcls = 0.d0
     rclp = 0.d0
 
  endif

  ! sum radial sources from external source time history and recycling
  ! The radial profile of externally injected neutrals and recycled neutrals can be different,
  !   depending on the energy set to the recycling neutrals (and to the calculated reflection
  !   and sputtering energies, if the full PWI model is used)
  
  if (en_rec_neut) then
     
     if (PWI) then   ! Full PWI model used --> reflected and sputtered neutrals are energetic
        rn(:,1) = src_prof   ! Add contribute of externally injected neutrals
        rn(:,1) = rn(:,1) + rfl_rad_prof*(rclw_refl)   ! Add contribute of energetic reflected neutrals
        rn(:,1) = rn(:,1) + rcl_rad_prof*(rclw_recl)   ! Add contribute of thermally recycled neutrals
        do s = 1,1+species
           rn(:,1) = rn(:,1) + spt_rad_prof(:,s)*(main_fluxes_sput(s))   ! Add contribute of energetic sputtered neutrals
        enddo
        rn(:,1) = rn(:,1) + rcl_rad_prof*(rclp + rclb)   ! Add contribute of thermal neutrals returned/leaked from divertor

     else   ! Simple PWI model used --> recycled neutrals will be thermal regardless of en_rec_neut
        rn(:,1) = src_prof + rcl_rad_prof*(rclw + rclp + rclb)

     endif
  
  else   ! Recycled neutrals (also the reflected and sputtered ones) are always thermal regardless of the used PWI model
  
     rn(:,1) = src_prof + rcl_rad_prof*(rclw + rclp + rclb)
  
  endif
  
  dt = det/2.
  !     ********** first half time step direction up ********

  do nz=2,nion
     !     r=0
     a(1,nz)=0.
     c(1,nz)=-2.*dt*diff(1,nz)*pro(1)
     b(1,nz)=1.-c(1,nz)+2.*dt*conv(2,nz)/der
     d1(1)=ra(1,nz)*(2.-b(1,nz))-ra(2,nz)*c(1,nz)

     !     r=r or at r+db respectively

     if (dlen > 0.d0) then
        temp1=4.*dt*pro(ir)**2*diff(ir,nz)
        temp2=.5*dt*(qpr(ir)*diff(ir,nz)-pro(ir)*conv(ir,nz))
        temp3=.5*dt*(par_loss_rate(ir)+conv(ir,nz)/rr(ir))
        temp4=1./pro(ir)/dlen

        a(ir,nz)=-temp1
        b(ir,nz)=1.+(1.+.5*temp4)*temp1+temp4*temp2+temp3
        c(ir,nz)=0.d0
        d1(ir)=-ra(ir-1,nz)*a(ir,nz)+ra(ir,nz)*(2.-b(ir,nz))
        b(ir,nz)=b(ir,nz)+dt*s_rates(ir,nz)
        d1(ir)=d1(ir)-dt*( ra(ir,nz)*r_rates(ir,nz-1) -rn(ir,nz-1)*s_rates(ir,nz-1))
        if (nz < nion) d1(ir)=d1(ir)+dt*ra(ir,nz+1)*r_rates(ir,nz)
     end if
     if (dlen <= 0.d0) then !Edge Conditions for rn(ir)=0.
        a(ir,nz)=0
        b(ir,nz)=1.
        c(ir,nz)= 0.
        d1(ir)=ra(ir,nz)
     end if

     !     normal coefficients

     do i=2,ir-1

        temp1=dt*pro(i)**2
        temp2=4.*temp1*diff(i,nz)
        temp3=dt/2.*(par_loss_rate(i)+pro(i)*(conv(i+1,nz)-conv(i-1,nz))+ conv(i,nz)/rr(i))
        a(i,nz)=.5*dt*qpr(i)*diff(i,nz)+temp1* (.5*(diff(i+1,nz)-diff(i-1,nz)  &
             -conv(i,nz)/pro(i))-2.*diff(i,nz))
        b(i,nz)=1.+temp2+temp3
        c(i,nz)=-temp2-a(i,nz)
        d1(i)=-ra(i-1,nz)*a(i,nz)+ra(i,nz)*(2.-b(i,nz)) -ra(i+1,nz)*c(i,nz)
     end do

     do i=1,ir-1
        b(i,nz)=b(i,nz)+dt*s_rates(i,nz)
        d1(i)=d1(i)-dt*(ra(i,nz)*r_rates(i,nz-1) -rn(i,nz-1)*s_rates(i,nz-1))   !ra --> "alt" (i-1) density; rn --> "current" (i) density
        if (nz < nion) d1(i)=d1(i)+dt*ra(i,nz+1)*r_rates(i,nz)   !r_rates --> recomb; s_rates --> ioniz
     end do

     !     solution of tridiagonal equation system

     bet(1)=b(1,nz)
     gam(1)=d1(1)/b(1,nz)
     do i=2,ir
        bet(i)=b(i,nz)-(a(i,nz)*c(i-1,nz))/bet(i-1)
        gam(i)=(d1(i)-a(i,nz)*gam(i-1))/bet(i)
     end do
     rn(ir,nz)=gam(ir)

     do i=ir-1,1,-1
        rn(i,nz)=gam(i)-(c(i,nz)*rn(i+1,nz))/bet(i)
     end do

  end do

  !     ********** second half time step Z-direction down ********

  do nz=nion,2,-1

     !     r=0
     a(1,nz)=0.
     c(1,nz)=-2.*dt*diff(1,nz)*pro(1)
     b(1,nz)=1.-c(1,nz)+2.*dt*conv(2,nz)/der
     d1(1)=rn(1,nz)*(2.-b(1,nz))-rn(2,nz)*c(1,nz)

     !     r=r or at r+db respectively
     if (dlen > 0.d0) then
        temp1=4.*dt*pro(ir)**2*diff(ir,nz)
        temp2=.5*dt*(qpr(ir)*diff(ir,nz)-pro(ir)*conv(ir,nz))
        temp3=.5*dt*(par_loss_rate(ir)+conv(ir,nz)/rr(ir))
        temp4=1./pro(ir)/dlen

        a(ir,nz)=-temp1
        b(ir,nz)=1.+(1.+.5*temp4)*temp1+temp4*temp2+temp3
        c(ir,nz)=0.d0
        d1(ir)=-rn(ir-1,nz)*a(ir,nz)+rn(ir,nz)*(2.-b(ir,nz))
        b(ir,nz)=b(ir,nz)+dt*r_rates(ir,nz-1)
        d1(ir)=d1(ir)-dt*(rn(ir,nz)*s_rates(ir,nz) -rn(ir,nz-1)*s_rates(ir,nz-1))
        if (nz < nion) d1(ir)=d1(ir)+dt*rn(ir,nz+1)*r_rates(ir,nz)  !!!!
     end if
     if (dlen <= 0.d0) then !Edge Conditions for rn(ir)=0.
        a(ir,nz)=0
        b(ir,nz)=1.
        c(ir,nz)= 0.
        d1(ir)=rn(ir,nz)
     end if

     !     normal coefficients

     do i=2,ir-1
        temp1=dt*pro(i)**2
        temp2=4.*temp1*diff(i,nz)
        temp3=dt/2.*(par_loss_rate(i)+pro(i)*(conv(i+1,nz)-conv(i-1,nz))+ conv(i,nz)/rr(i))

        a(i,nz)=.5*dt*qpr(i)*diff(i,nz)+temp1* (.5*(diff(i+1,nz)-diff(i-1,nz)  &
             -conv(i,nz)/pro(i))-2.*diff(i,nz))
        b(i,nz)=1.+temp2+temp3
        c(i,nz)=-temp2-a(i,nz)
        d1(i)=-rn(i-1,nz)*a(i,nz)+rn(i,nz)*(2.-b(i,nz)) -rn(i+1,nz)*c(i,nz)
     end do

     do i=1,ir-1
        b(i,nz)=b(i,nz)+dt*r_rates(i,nz-1)
        d1(i)=d1(i)-dt*(rn(i,nz)*s_rates(i,nz)- rn(i,nz-1)*s_rates(i,nz-1))
        if (nz < nion) d1(i)=d1(i)+dt*rn(i,nz+1)*r_rates(i,nz)   !!!!!
     end do

     !     solution of tridiagonal equation system

     bet(1)=b(1,nz)
     gam(1)=d1(1)/b(1,nz)
     do i=2,ir
        bet(i)=b(i,nz)-(a(i,nz)*c(i-1,nz))/bet(i-1)
        gam(i)=(d1(i)-a(i,nz)*gam(i-1))/bet(i)
     end do
     rn(ir,nz)=gam(ir)    !!!!

     do i=ir-1,1,-1
        rn(i,nz)=gam(i)-(c(i,nz)*rn(i+1,nz))/bet(i)     !!!!
     end do
  end do


  return
end subroutine impden0





subroutine impden1(nion, ir, species, ra, rn, diff, conv, par_loss_rate, &
     src_prof, rcl_rad_prof, rfl_rad_prof, spt_rad_prof, en_rec_neut, s_rates, r_rates,  &
     Raxis, rr, fall_outsol, det,  &    ! renaming dt-->det. In this subroutine, dt is half-step
     surfmain, surfdiv, PWI, Zmain, Zdiv, &
     rnmain, rndiv, fluxmain, fluxdiv, ymain, ydiv, depthmain, depthdiv, nmainsat, ndivsat, & 
     rcl, screen, rcmb, tsuold, dsuold, dsulold, divold, pumpold, taudiv, tauwret, leak, volpump, &
     evolveneut, Nmainret, Ndivret, rcld, rcld_refl, rcld_recl, div_flux_impl, div_fluxes_sput, &
     rclb, rcls, rclp, rclw, rclw_refl, rclw_recl, main_flux_impl, main_fluxes_sput)
  !
  !  Impurity transport forward modeling with Linder's finite-volume scheme.
  !  See Linder et al. NF 2020
  !  The recycling/pumping model is however the same as in impden0.
  !
  ! ----------------------------------------------------------------------|
  implicit none
    
  INTEGER, INTENT(IN)       :: nion
  INTEGER, INTENT(IN)       :: ir
  INTEGER, INTENT(IN)       :: species
  REAL*8, INTENT(IN)        :: ra(ir,nion)   ! old imp density
  REAL*8, INTENT(OUT)       :: rn(ir,nion)   ! new imp density
  REAL*8, INTENT(IN)        :: diff(ir, nion)
  REAL*8, INTENT(IN)        :: conv(ir, nion)
  REAL*8, INTENT(IN)        :: par_loss_rate(ir)
  REAL*8, INTENT(IN)        :: src_prof(ir)
  REAL*8, INTENT(IN)        :: rcl_rad_prof(ir)
  REAL*8, INTENT(IN)        :: rfl_rad_prof(ir)
  REAL*8, INTENT(IN)        :: spt_rad_prof(ir,1+species)
  LOGICAL, INTENT(IN)       :: en_rec_neut
  REAL*8, INTENT(IN)        :: s_rates(ir,nion)    ! ionization
  REAL*8, INTENT(IN)        :: r_rates(ir,nion)   ! recombination
  REAL*8, INTENT(IN)        :: Raxis
  REAL*8, INTENT(IN)        :: rr(ir)
  REAL*8, INTENT(IN)        :: fall_outsol  !dlen ! decay length at last radial grid point
  REAL*8, INTENT(IN)        :: det   ! full time step, named dt in subroutine `run'

  ! plasma-wall interaction inputs
  REAL*8, INTENT(IN)        :: surfmain
  REAL*8, INTENT(IN)        :: surfdiv
  LOGICAL, INTENT(IN)       :: PWI
  INTEGER, INTENT(IN)       :: Zmain
  INTEGER, INTENT(IN)       :: Zdiv
  REAL*8, INTENT(IN)        :: rnmain
  REAL*8, INTENT(IN)        :: rndiv
  REAL*8, INTENT(IN)        :: fluxmain(species)
  REAL*8, INTENT(IN)        :: fluxdiv(species)
  REAL*8, INTENT(IN)        :: ymain(1+species)
  REAL*8, INTENT(IN)        :: ydiv(1+species)
  REAL*8, INTENT(IN)        :: depthmain
  REAL*8, INTENT(IN)        :: depthdiv
  REAL*8, INTENT(IN)        :: nmainsat
  REAL*8, INTENT(IN)        :: ndivsat

  ! recycling inputs
  REAL*8, INTENT(IN)        :: rcl
  REAL*8, INTENT(IN)        :: screen
  REAL*8, INTENT(IN)        :: rcmb
  REAL*8, INTENT(INOUT)     :: tsuold   ! tsu from previous recycling step
  REAL*8, INTENT(INOUT)     :: dsuold   ! dsu from previous recycling step
  REAL*8, INTENT(INOUT)     :: dsulold  ! dsul from previous recycling step
  REAL*8, INTENT(IN)        :: divold   ! divnew from previous step (even without backflow)
  REAL*8, INTENT(IN)        :: pumpold  ! pumpnew from previous step (even without leakage)

  REAL*8, INTENT(IN)        :: taudiv
  REAL*8, INTENT(IN)        :: tauwret
  REAL*8, INTENT(IN)        :: leak
  REAL*8, INTENT(IN)        :: volpump

  ! Extras
  LOGICAL, INTENT(IN)       :: evolveneut
  
  REAL*8, INTENT(INOUT)     :: Nmainret
  REAL*8, INTENT(INOUT)     :: Ndivret
  REAL*8, INTENT(OUT)       :: rcld
  REAL*8, INTENT(OUT)       :: rcld_refl
  REAL*8, INTENT(OUT)       :: rcld_recl
  REAL*8, INTENT(OUT)       :: div_flux_impl
  REAL*8, INTENT(OUT)       :: div_fluxes_sput(1+species)
  REAL*8, INTENT(OUT)       :: rclb
  REAL*8, INTENT(OUT)       :: rcls
  REAL*8, INTENT(OUT)       :: rclp
  REAL*8, INTENT(OUT)       :: rclw
  REAL*8, INTENT(OUT)       :: rclw_refl
  REAL*8, INTENT(OUT)       :: rclw_recl
  REAL*8, INTENT(OUT)       :: main_flux_impl
  REAL*8, INTENT(OUT)       :: main_fluxes_sput(1+species)

  REAL*8 :: src(ir), tauleak
  INTEGER :: i, nz, ns, s

  REAL*8 :: dt

  ! nt is the solution of the TDMA
  real*8 ::  nt(ir), a(ir), b(ir), c(ir), d(ir)
  
  ! Lackner method: split time step in 2 half time steps
  dt = det/2.    
  
  ! Plasma-wall interaction
  
  if (PWI) then   ! full plasma-wall interaction model: wall content and fluxes determined by reflection, sputtering and wall saturation level
  
     if (rcl.ge.0) then
        rcls = (divold/taudiv)*(screen)
     else
        rcls = 0.d0
     endif
     
     call advanced_PWI_model(det, Raxis, tsuold, dsulold, dsuold, rcls, species, &
          rcmb, surfmain, surfdiv, Zmain, Zdiv, depthmain, depthdiv, nmainsat, ndivsat, &
          fluxmain, fluxdiv, rnmain, rndiv, ymain, ydiv, &
          Nmainret, Ndivret, &
          rclw, rclw_refl, rclw_recl, main_flux_impl, main_fluxes_sput, &
          rcld, rcld_refl, rcld_recl, div_flux_impl, div_fluxes_sput)
  
  else   ! simple plasma-wall interaction model: wall content and fluxes determined by simple recl. coeff. and retention time
  
     if (rcl.ge.0) then   ! recycling activated --> fluxes rclw, rcld present
  
        rclw = rcl*(tsuold+dsulold)   ! OLD flux towards main wall which can be recycled
        rcld = rcl*(1.-rcmb)*(dsuold+rcls)   ! OLD flux towards divertor wall which can be recycled
     
        if (tauwret.gt.0.0d0) then
           ! include flux from particles previously retained at the main wall
           Nmainret = Nmainret * (1-det/tauwret) + rclw*det   ! number of particles temporarily retained at main wall
           Ndivret = Ndivret * (1-det/tauwret) + rcld*det     ! number of particles temporarily retained at divertor wall
           rclw = Nmainret/tauwret   ! total recycled flux from main wall which will be a NEW source for the core plasma
           rcld = Ndivret/tauwret   ! total recycled flux from divertor wall which will be a NEW source for the divertor neutrals reservoir
        
        endif
     
     else   ! recycling de-activated --> no fluxes rclw, rcld, and temporary wall reservoirs are not filled
  
        rcld = 0.d0
        rclw = 0.d0
 
     endif
     
     rclw_refl = 0.d0
     rcld_refl = 0.d0
     rclw_recl = 0.d0
     rcld_recl = 0.d0
     main_flux_impl = 0.d0
     div_flux_impl = 0.d0
     do s = 1,1+species
        main_fluxes_sput(s) = 0.d0
        div_fluxes_sput(s) = 0.d0
     enddo
  
  endif
  
  ! Backflow from divertor
  
  if (rcl.ge.0) then   ! activated divertor/pump return --> fluxes rclb, rcls, rclp present
  
     rclb = (divold/taudiv)*(1-screen) ! non-screened backflow from previous time step
     rcls = (divold/taudiv)*(screen) ! screened backflow from previous time step
     if (leak.gt.0) then    ! pump reservoir present and activated leakage
        tauleak = volpump/leak
        rclp = pumpold/tauleak
     else
        rclp = 0.d0
     endif
     
  else   ! no divertor/pump return --> no fluxes rclb, rcls, rclp at all
  
     rclb = 0.d0
     rcls = 0.d0
     rclp = 0.d0
 
  endif
  
  ! sum radial sources from external source time history and recycling
  ! The radial profile of externally injected neutrals and recycled neutrals can be different,
  !   depending on the energy set to the recycling neutrals (and to the calculated reflection
  !   and sputtering energies, if the full PWI model is used)

  if (en_rec_neut) then
     
     if (PWI) then   ! Full PWI model used --> reflected and sputtered neutrals are energetic
        src = src_prof   ! Add contribute of externally injected neutrals
        src = src + rfl_rad_prof*(rclw_refl)   ! Add contribute of energetic reflected neutrals
        src = src + rcl_rad_prof*(rclw_recl)   ! Add contribute of thermally recycled neutrals
        do s = 1,1+species
           src = src + spt_rad_prof(:,s)*(main_fluxes_sput(s))   ! Add contribute of energetic sputtered neutrals
        enddo
        src = src + rcl_rad_prof*(rclp + rclb)   ! Add contribute of thermal neutrals returned/leaked from divertor

     else   ! Simple PWI model used --> recycled neutrals will be thermal regardless of en_rec_neut
        src = src_prof + rcl_rad_prof*(rclw + rclp + rclb)

     endif

  else   ! Recycled neutrals (also the reflected and sputtered ones) are always thermal regardless of the used PWI model

     src = src_prof + rcl_rad_prof*(rclw + rclp + rclb)

  endif 
  
  ! select whether neutrals should be evolved
  ns = 2
  if (evolveneut) ns = 1


  ! ----- First half time step: direction up --------------------|
  ! Externally provided neutrals
  if (ns.eq.1) then
     call impden_constTranspMatrix(ra(:,1), diff(:,1), conv(:,1),&    !na(1), nd(1), nv(1),&
          ir, dt, fall_outsol, par_loss_rate, rr, a, b, c, d)

     do i=1,ir
        b(i)    = b(i) + dt*s_rates(i,1)
        d(i)    = d(i) + dt*src(i)
     enddo
     call TDMA(a, b, c, d, ir, nt)
  else
     nt = 0.d0
     ! radial profile of neutrals (given as input)
     do i=1,ir
        rn(i,1) = src(i)
     end do
  endif
  
  ! Ions and recombined neutrals
  do nz=ns,nion             
     ! Construct transport matrix
     call impden_constTranspMatrix(ra(:,nz), diff(:,nz),&
          conv(:,nz), ir, dt, fall_outsol, par_loss_rate, rr, a, b, c, d)
     
     ! Add ionization and recombination
     do i=1,ir
        b(i)    = b(i) + dt*s_rates(i,nz)
        if (nz.gt.1)&
             d(i)    = d(i) + dt*(rn(i,nz-1)*s_rates(i,nz-1) - ra(i,nz)*r_rates(i,nz-1))
        if (nz.lt.nion)&
             d(i)    = d(i) + dt*ra(i,nz+1)*r_rates(i,nz)
        if (nz.eq.2)&
             d(i)    = d(i) + dt*nt(i)*s_rates(i,1)
     enddo
     
     ! Solve tridiagonal system of equations
     call TDMA(a, b, c, d, ir, rn(:,nz))
  enddo
  
  ! ----- Second half time step: direction down -----------------|
  ! Ions and recombined neutrals
  do nz=nion,ns,-1
     ! Construct transport matrix
     call impden_constTranspMatrix(rn(:,nz), diff(:,nz),&
          conv(:,nz), ir, dt, fall_outsol, par_loss_rate, rr, a, b, c, d)
     
     ! Add ionization and recombination
     do i=1,ir
        d(i)    = d(i) - dt*rn(i,nz)*s_rates(i,nz)
        if (nz.gt.1) then
           b(i)    = b(i) + dt*r_rates(i,nz-1)
           d(i)    = d(i) + dt*rn(i,nz-1)*s_rates(i,nz-1)
        endif
        if (nz.lt.nion) &
             d(i)    = d(i) + dt*rn(i,nz+1)*r_rates(i,nz) 
        if (nz.eq.2) &
             d(i)    = d(i) + dt*nt(i)*s_rates(i,1)
     enddo
     
     ! Solve tridiagonal equation system
     call TDMA(a, b, c, d, ir, rn(:,nz))
  enddo
  
  ! Externally provided neutrals
  if (ns.eq.1) then
     call impden_constTranspMatrix(nt, diff(:,1), conv(:,1), ir,&
          dt, fall_outsol, par_loss_rate, rr, a, b, c, d)
          
     do i=1,ir
        d(i)    = d(i) - dt*nt(i)*s_rates(i,1) + dt*src(i)
     enddo
     call TDMA(a, b, c, d, ir, rn(:,1))
  endif
    
  ! ----- Calculate ionization rate -----------------------------|
  ! Bulk ions & neutrals
  ! do nz=1,nion-1
  !    do i=1,ir
  !       ioniz_loss(i,nz) = s(i,nz)*rn(i,nz)
  !    enddo
  ! enddo
  ! ! External neutrals
  ! do i=1,ir
  !    ioniz_loss(i,1) = ioniz_loss(i,1) + nt(i)*s_rates(i,1)
  ! enddo
  
  return
end subroutine impden1
!======================================================================|





!======================================================================|
subroutine impden_constTranspMatrix(rnt, dimp, vimp, ir, dt, &
     fall_outsol, par_loss_rate, rr, a, b, c, d)
  ! ----------------------------------------------------------------------|
  !     Construct transport matrix for charge state IZ of impurity 
  !     species IM.
  ! ----------------------------------------------------------------------|
  implicit none
  
  ! ----- Global variables --------------------------------------|
  integer, intent(in) ::  ir
  
  real*8, intent(in) :: rnt(ir), dt, fall_outsol, dimp(ir), vimp(ir),&
       par_loss_rate(ir), rr(ir)
  
  real*8, intent(out) ::  a(ir), b(ir), c(ir), d(ir)
  
  ! ----- Local variables ---------------------------------------|
  real*8 :: coefm, coefp, Dm, Dp, drm, drp, gi, kam, kap, rm, rp, vm, vp
  
  integer :: i
  
  ! ----------------------------------------------------------------------|
  !     Temporal component
  ! ----------------------------------------------------------------------|
  a(:) = 0
  b(:) = 1
  c(:) = 0
  d(:) = rnt(:)
  
  ! ----------------------------------------------------------------------|
  !   Central point (r = 0)
  !   Enforces dn/dr|_r=0 = 0 and v(r=0) = 0
  ! ----------------------------------------------------------------------|
  ! ----- Geometric factors -------------------------------------|
  drp   = rr(2)-rr(1)
  rp    = .5*(rr(1)+rr(2))
  gi    = 2./(rp**2)
  
  ! ----- Diffusion contribution --------------------------------|
  Dp    = .5*(dimp(1)+dimp(2))
  coefp = .5*dt*gi*rp*Dp/drp
  
  a(1)  = a(1)
  b(1)  = b(1) + coefp
  c(1)  = c(1) - coefp
  d(1)  = d(1) + coefp*(rnt(2) - rnt(1))
  
  ! ----- Advection contribution --------------------------------|
  vp    = .5*(vimp(1)+vimp(2))
  kap   = 0.
  if (abs(vp).gt.2.*Dp/drp) kap = sign(max(0.d0, 1.-2.*Dp/(drp*abs(vp))), vp)
  
  coefp = .25*dt*gi*rp*vp
  
  a(1)  = a(1)
  b(1)  = b(1) + coefp*(1+kap)
  c(1)  = c(1) + coefp*(1-kap)
  d(1)  = d(1) - coefp*((1+kap)*rnt(1) + (1-kap)*rnt(2))
  
  ! ----------------------------------------------------------------------|
  !     Interior points
  ! ----------------------------------------------------------------------|
  do i=2,ir-1
     ! ----- Geometric factors -------------------------------------|
     drm     = drp
     drp     = rr(i+1)-rr(i)
     rm      = rp
     rp      = .5*(rr(i)+rr(i+1))
     gi      = 2./(rp**2-rm**2)
     
     ! ----- Diffusion contribution --------------------------------|
     Dm      = Dp
     Dp      = .5*(dimp(i)+dimp(i+1))
     coefm   = .5*dt*gi*rm*Dm/drm
     coefp   = .5*dt*gi*rp*Dp/drp
     
     a(i)    = a(i) - coefm
     b(i)    = b(i) + coefm + coefp
     c(i)    = c(i)         - coefp
     d(i)    = d(i) - coefm*(rnt(i  ) - rnt(i-1))&
                    + coefp*(rnt(i+1) - rnt(i  ))
     
     ! ----- Advection contribution --------------------------------|
     vm      = vp
     vp      = .5*(vimp(i)+vimp(i+1))
     
     kam     = 0.
     if (abs(vm).gt.2.*Dm/drm)&
          kam     = sign(max(0.d0, 1.-2.*Dm/(drm*abs(vm))), vm)
     kap     = 0.
     if (abs(vp).gt.2.*Dp/drp)&
          kap     = sign(max(0.d0, 1.-2.*Dp/(drp*abs(vp))), vp)
     
     coefm   = .25*dt*gi*rm*vm
     coefp   = .25*dt*gi*rp*vp
     
     a(i)    = a(i) - coefm*(1+kam)
     b(i)    = b(i) - coefm*(1-kam) + coefp*(1+kap)
     c(i)    = c(i)                 + coefp*(1-kap)
     d(i)    = d(i) + coefm*((1+kam)*rnt(i-1) + (1-kam)*rnt(i  ))&
                    - coefp*((1+kap)*rnt(i  ) + (1-kap)*rnt(i+1))

  enddo
  
  !----------------------------------------------------------------------|
  !     Outer point (r = r)
  !----------------------------------------------------------------------|
  ! ----- Geometric factors -------------------------------------|
  drm       = drp
  rm        = rp
  rp        = rr(ir) + .5*drm
  gi        = 2./(rp**2-rm**2)
  
  ! ----- Diffusion contribution --------------------------------|
  Dm        = Dp
  Dp        = dimp(ir)
  coefm     = .5*dt*gi*rm*Dm/drm
  coefp     = .5*dt*gi*rp*Dp
  
  a(ir)     = a(ir)- coefm
  b(ir)     = b(ir)+ coefm 
  d(ir)     = d(ir)- coefm*(rnt(ir) - rnt(ir-1))
  
  if (fall_outsol.gt.0.d0) then
     b(ir)   = b(ir)+ coefp/fall_outsol
     d(ir)   = d(ir)- coefp/fall_outsol*rnt(ir)
  endif
  
  ! ----- Advection contribution --------------------------------|
  vm        = vp
  vp        = max(0.d0, vimp(ir))
  
  kam       = 0.
  if (abs(vm).gt.2.*Dm/drm)&
       kam = sign(max(0.d0, 1.d0-2.d0*Dm/(drm*abs(vm))), vm)
  kap       = 0.
  if (abs(vp).gt.2.*Dp/drp)&
       kap = sign(max(0.d0, 1.d0-2.d0*Dp/(drp*abs(vp))), vp)
  
  coefm     = .25*dt*gi*rm*vm
  coefp     = .25*dt*gi*rp*vp
  
  a(ir)     = a(ir)- coefm*(1+kam)
  b(ir)     = b(ir)- coefm*(1-kam) 
  d(ir)     = d(ir)+ coefm*((1+kam)*rnt(ir-1) + (1-kam)*rnt(ir))
  
  if (fall_outsol.gt.0.d0) then
     b(ir)   = b(ir)+ coefp*(2-(1-kap)*drp/fall_outsol)
     d(ir)   = d(ir)- coefp*(2-(1-kap)*drp/fall_outsol)*rnt(ir)
  endif
  
  !----------------------------------------------------------------------|
  ! SOL Losses
  !----------------------------------------------------------------------|
  ! ----- Interior points ---------------------------------------|
  do i=2,ir-1
     coefm   = .5*dt*par_loss_rate(i)
     
     b(i)    = b(i) +  coefm
     d(i)    = d(i) -  coefm*rnt(i)
  enddo
  
  ! ----- Outer point (r = r) -----------------------------------|
  if (fall_outsol.gt.0.d0) then
     coefm   = .5*dt*par_loss_rate(ir)
     
     b(i)    = b(i) +  coefm
     d(i)    = d(i) -  coefm*rnt(ir)
  endif
  
  return
end subroutine impden_constTranspMatrix






!======================================================================|
subroutine TDMA(dLow, dMain, dUpp, rhs, n, sol)
  ! ---------------------------------------------------------------------|
  !     TriDiagonal Matrix Algorithm:
  !     Solves linear system of equations if coefficient matrix M is in a
  !     tridiagonal form. 
  !     See: https://en.wikipedia.org/wiki/Tridiagonal_matrix_algorithm
  !
  !     Input:
  !       dLow        Lower diagonal M(i,i-1). Starts with element 
  !                   M(1,n) = 0.
  !       dMain       Main diagonal M(i,i).
  !       dUpp        Upper diagnonal M(i,i+1). Ends with element 
  !                   M(n,1) = 0.
  !       rhs         Right-hand-side of system of equations
  !       n           Number of equations.
  !     Output:
  !       sol         Solution of system of equations.
  ! ---------------------------------------------------------------------|
  implicit none
  
  ! ----- I/O variables -----------------------------------------|
  real*8, dimension(n), intent(in) :: dLow, dMain, dUpp, rhs
  integer, intent(in) :: n
  
  real*8, dimension(n), intent(out) ::  sol 
  
  ! ----- Local variables ---------------------------------------|
  integer :: i
  
  real*8, dimension(n) :: rhsP, dMainP
  
  
  ! ----- Modify coefficients -----------------------------------|
  dMainP(1) = dMain(1); rhsP(1) = rhs(1)
  do i=2,n
     dMainP(i) = dMain(i) - dLow(i)*dUpp(i-1)/dMainP(i-1)
     rhsP(i) = rhs(i) - dLow(i)*rhsP(i-1)/dMainP(i-1) 
  enddo
  
  ! ----- Construct solution ------------------------------------|
  sol(n) = rhsP(n)/dMainP(n)  
  do i=n-1,1,-1
     sol(i) = (rhsP(i) - dUpp(i)*sol(i+1))/dMainP(i)
  enddo

  return
end subroutine TDMA






!============================================================================================|
subroutine advanced_PWI_model(det, Raxis, tsuold, dsulold, dsuold, rcls, species, &
     rcmb, surfmain, surfdiv, Zmain, Zdiv, depthmain, depthdiv, nmainsat, ndivsat, &
     fluxmain, fluxdiv, rnmain, rndiv, ymain, ydiv, &
     Nmainret, Ndivret, &
     rclw, rclw_refl, rclw_recl, main_flux_impl, main_fluxes_sput, &
     rcld, rcld_refl, rcld_recl, div_flux_impl, div_fluxes_sput)
  ! -----------------------------------------------------------------------------------------|
  !  Apply the full plasma-wall interaction model for the calculation of
  !    reflected, recycled and sputtered fluxes at the walls
  ! -----------------------------------------------------------------------------------------|
  implicit none
  
  ! ----- I/O variables ---------------------------------------------------------------------|
  
  real*8,  intent(in)     :: det
  real*8,  intent(in)     :: Raxis
  real*8,  intent(inout)  :: tsuold
  real*8,  intent(inout)  :: dsulold
  real*8,  intent(inout)  :: dsuold 
  real*8,  intent(inout)  :: rcls
  integer, intent(in)     :: species
  
  real*8,  intent(in)     :: rcmb
  real*8,  intent(in)     :: surfmain
  real*8,  intent(in)     :: surfdiv
  integer, intent(in)     :: Zmain
  integer, intent(in)     :: Zdiv
  real*8,  intent(in)     :: depthmain
  real*8,  intent(in)     :: depthdiv
  real*8,  intent(in)     :: nmainsat
  real*8,  intent(in)     :: ndivsat
  
  real*8,  intent(in)     :: fluxmain(species)
  real*8,  intent(in)     :: fluxdiv(species)
  real*8,  intent(in)     :: rnmain
  real*8,  intent(in)     :: rndiv
  real*8,  intent(in)     :: ymain(1+species)
  real*8,  intent(in)     :: ydiv(1+species)
  
  real*8,  intent(inout)  :: Nmainret 
  real*8,  intent(inout)  :: Ndivret
  
  real*8,  intent(inout)  :: rclw 
  real*8,  intent(inout)  :: rclw_refl
  real*8,  intent(inout)  :: rclw_recl
  real*8,  intent(inout)  :: main_flux_impl
  real*8,  intent(inout)  :: main_fluxes_sput(1+species)
  
  real*8,  intent(inout)  :: rcld 
  real*8,  intent(inout)  :: rcld_refl
  real*8,  intent(inout)  :: rcld_recl
  real*8,  intent(inout)  :: div_flux_impl
  real*8,  intent(inout)  :: div_fluxes_sput(1+species)
  
  ! ----- Local variables -------------------------------------------------------------------|
  real*8     :: circ
  real*8     :: sigmamainret
  real*8     :: sigmadivret
  real*8     :: mainsatlevel
  real*8     :: divsatlevel
  real*8     :: rclw_sput
  real*8     :: rcld_sput
  real*8     :: Cmain
  real*8     :: Cdiv
  integer    :: s
  
  circ = 2.0 * 3.14159 * Raxis
    
  ! convert old fluxes and content into absolute quantities
  tsuold = tsuold * circ   ! OLD radial edge flux to main wall in s^-1
  dsulold = dsulold * circ   ! OLD parallel limiter flux to main wall in s^-1
  dsuold = dsuold * circ   ! OLD parallel loss to divertor wall in s^-1
  rcls = rcls * circ   ! OLD screened divertor backflow from divertor wall in s^-1
  Nmainret = Nmainret * circ   ! OLD absolute number of particles retained at the main wall
  Ndivret = Ndivret * circ   ! OLD absolute number of particles retained at the main wall

  rclw_refl = (tsuold+dsulold) * rnmain   ! reflected impurity flux from main wall in s^-1 (NEW source for core plasma)
  rcld_refl = (1.-rcmb)*(dsuold+rcls) * rndiv   ! reflected impurity flux from divertor wall in s^-1 (NEW source for divertor reservoir)
 
  sigmamainret = (Nmainret / surfmain) * 1.0E4   ! OLD surface implantation density at the main wall in m^-2
  sigmadivret = (Ndivret / surfdiv) * 1.0E4   ! OLD surface implantation density at the divertor wall in m^-2
 
  mainsatlevel = sigmamainret / nmainsat   ! OLD saturation level of the main wall
  divsatlevel = sigmadivret / ndivsat   ! OLD saturation level of the main wall
 
  rclw_recl = (tsuold+dsulold) * (1.0 - rnmain) * mainsatlevel   ! promptly recycled flux into the main wall in s^-1 (NEW source for core plasma)
  rcld_recl = (1.-rcmb)*(dsuold+rcls) * (1.0 - rndiv) * divsatlevel   ! promptly recycled flux into the divertor wall in s^-1 (NEW source for core plasma)
 
  main_flux_impl = (tsuold+dsulold) * (1.0 - rnmain) * (1.0 - mainsatlevel)   ! implanted flux into the main wall in s^-1
  div_flux_impl = (1.-rcmb)*(dsuold+rcls) * (1.0 - rndiv) * (1.0 - divsatlevel)   ! implanted flux into the divertor wall in s^-1
 
  ! Convert OLD surface implantation densities, in m^-2, into concentrations
  call wall_density_to_concentration(sigmamainret, Zmain, depthmain, Cmain)   ! OLD impurity concentration at the main wall
  call wall_density_to_concentration(sigmadivret, Zdiv, depthdiv, Cdiv)   ! OLD impurity concentration at the divertor wall

  do s = 1,1
     main_fluxes_sput(s) = (tsuold+dsulold) * (ymain(s)*Cmain)   ! sputtered flux from main wall due to impurity self-bombardment in s^-1
     div_fluxes_sput(s) = (1.-rcmb)*(dsuold+rcls) * (ydiv(s)*Cdiv)   ! sputtered flux from divertor wall due to impurity self-bombardment in s^-1
     rclw_sput = main_fluxes_sput(s)
     rcld_sput = div_fluxes_sput(s)
  enddo
 
  do s = 2,1+species
     main_fluxes_sput(s) = fluxmain(s-1) * (ymain(s)*Cmain)   ! sputtered fluxes from main wall due to background bombardment in s^-1
     rclw_sput = rclw_sput + main_fluxes_sput(s)   ! total sputtered flux from main wall in s^-1 (updated) (NEW source for core plasma)
     div_fluxes_sput(s) = fluxdiv(s-1) * (ydiv(s)*Cdiv)   ! sputtered fluxes from main wall due to background bombardment in s^-1
     rcld_sput = rcld_sput + div_fluxes_sput(s)   ! total sputtered flux from divertor wall in s^-1 (updated) (NEW source for divertor reservoir)
  enddo

  Nmainret = Nmainret + main_flux_impl*det - rclw_sput*det   ! NEW absolute number of particles retained at the main wall
  Ndivret = Ndivret + div_flux_impl*det - rcld_sput*det   ! NEW absolute number of particles retained at the main wall

  rclw = rclw_refl + rclw_recl + rclw_sput   ! total recycled flux from main wall which will be a NEW source for the core plasma in s^-1
  rcld = rcld_refl + rcld_recl + rcld_sput   ! total recycled flux from main wall which will be a NEW source for the divertor reservoir in s^-1

  ! convert again contents into cm^-1
  Nmainret = Nmainret / circ
  Ndivret = Ndivret / circ

  ! convert again fluxes into cm^-1 s^-1
  rclw_refl = rclw_refl / circ
  rcld_refl = rcld_refl / circ
  rclw_recl = rclw_recl / circ
  rcld_recl = rcld_recl / circ
  main_flux_impl = main_flux_impl / circ
  div_flux_impl = div_flux_impl / circ
  do s = 1,1+species
     main_fluxes_sput(s) = main_fluxes_sput(s) / circ
     div_fluxes_sput(s) = div_fluxes_sput(s) / circ
  enddo
  rclw = rclw / circ
  rcld = rcld / circ
  
  return
  
end subroutine advanced_PWI_model






!============================================================================================|
subroutine wall_density_to_concentration(sigma, Z_wall, depth, C)
  ! -----------------------------------------------------------------------------------------|
  !  Calculate the concentration of the implanted impurity into a bulk material
  !  starting from a given value of surface implantation density.
  !  The conversion will of course depend on the implantation depth.
  !
  !       Input:
  !       ----------
  !       sigma :
  !           Surface implantation density of the impurity in the bulk material, in m^-2.
  !       Z_wall : 
  !           Atomic number of the wall material.
  !       depth : 
  !           Depth of a uniform implantation profile of the impurity in the material, in A.
  !           
  !       Output:
  !       -------
  !       C: 
  !           Concentration of the impurity in the bulk material,
  !           in number of impurity atoms / total number of material atoms (bulk+imp)
  !
  ! -----------------------------------------------------------------------------------------|
  implicit none
  
  ! ----- I/O variables ---------------------------------------------------------------------|
  
  real*8,  intent(in)  :: sigma
  integer, intent(in)  :: Z_wall
  real*8,  intent(in)  :: depth
  
  real*8,  intent(out) :: C 
  
  ! ----- Local variables -------------------------------------------------------------------|
  real*8     :: rho
  real*8     :: M  
  real*8     :: avogadro  
  real*8     :: mol_density
  real*8     :: n_bulk
  real*8     :: depth_m
  real*8     :: n_imp
    
  
  ! density and molar mass of the bulk material
  
  if (Z_wall == 4) then   ! beryllium
     rho = 1.80   ! g/cm^3
     M = 9.01     ! g/mol
  endif
  if (Z_wall == 6) then   ! carbon
     rho = 1.85   ! g/cm^3
     M = 12.01    ! g/mol
  endif
  if (Z_wall == 74) then   ! tungsten
     rho = 19.29  ! g/cm^3
     M = 183.85   ! g/mol
  endif
        
  avogadro = 6.022E23   ! mol^-1
    
  ! calculate the molar density
  mol_density = rho / M   ! mol/cm^3
    
  ! calculate the bulk atom density
  n_bulk = avogadro * mol_density * 1.0E6   ! atoms/m^-3
    
  ! convert the surface implantation density into volumetric impurity atom density
  depth_m = depth * 1.0E-10   ! m
  n_imp = sigma/depth_m
    
  ! calculate the resulting impurity concentration
  C = (n_imp) / (n_imp + n_bulk)
  
  return
  
end subroutine wall_density_to_concentration

!MIT License
!
!Copyright (c) 2021 Francesco Sciortino
!
!Extended recycling model and full plasma-wall interaction model
!provided by Antonello Zito
!
!Permission is hereby granted, free of charge, to any person obtaining a copy
!of this software and associated documentation files (the "Software"), to deal
!in the Software without restriction, including without limitation the rights
!to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
!copies of the Software, and to permit persons to whom the Software is
!furnished to do so, subject to the following conditions:
!
!The above copyright notice and this permission notice shall be included in all
!copies or substantial portions of the Software.
!
!THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
!IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
!FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
!AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
!LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
!OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
!SOFTWARE.


subroutine run(  &
        nion, ir, nt, species, &
        nt_out,  nt_trans, &
        t_trans, D, V, &
        par_loss_rates, &
        src_core, rcl_rad_prof, rfl_rad_prof, spt_rad_prof, en_rec_neut, &
        S_rates, R_rates,  &
        Raxis, rr, pro, qpr, &
        r_saw, dlen,  &
        time, saw, &
        it_out, dsaw, &
        rcl, screen, rcmb, taudiv, taupump, tauwret, &
        S_pump, voldiv, cond, volpump, leak, &
        surfmain, surfdiv, PWI, Zmain, Zdiv, &
        rnmain, rndiv, fluxmain, fluxdiv, ymain, ydiv, depthmain, depthdiv, nmainsat, ndivsat, &
        rvol_lcfs, dbound, dlim, prox, &
        rn_t0, ndiv_t0, npump_t0, nmainwall_t0, ndivwall_t0, alg_opt, evolneut, src_div, &   ! OPTIONAL INPUTS:
        rn_out, &  ! OUT
        N_mainwall, N_divwall, N_div, N_pump, N_out, N_mainret, N_divret, &  ! OUT
        N_tsu, N_dsu, N_dsul, &   !OUT
        rcld_rate, rcld_refl_rate, rcld_recl_rate, rcld_impl_rate, rcld_sput_rate, &   ! OUT
        rclb_rate, rcls_rate, rclp_rate, &   ! OUT
        rclw_rate, rclw_refl_rate, rclw_recl_rate, rclw_impl_rate, rclw_sput_rate)   ! OUT
  !
  ! Run forward model of radial impurity transport, returning the density of
  ! each charge state over time and space. 
  !
  ! ------ All inputs are in CGS units -----
  !
  ! Get list of required input parameters in Python using 
  ! print(aurora.run.__doc__)
  !
  ! Args:
  !     nion         integer
  !                    Number of ionization stages. Not needed for Python calls.
  !     ir           integer
  !                    Number of radial grid points. Not needed for Python calls.
  !     nt           integer
  !                    Number of time steps for the solution. Not needed for Python calls.
  !     species      integer
  !                    Number of considered background species for the full PWI. Not needed for Python calls.
  !     nt_out       integer
  !                    Number of times at which the impurity densities shall be saved
  !     nt_trans     integer
  !                    Number of times at which D,V profiles are given. Not needed for Python calls.
  !     t_trans      real*8 (nt_trans)
  !                    Times at which transport coefficients change [s]
  !     D            real*8 (ir,nt_trans,nion)
  !                    Diffusion coefficient on time and radial grids [cm^2/s]
  !                    This must be given for each charge state and time.
  !     V            real*8 (ir,nt_trans,nion)
  !                    Drift velocity on time and radial grids [cm/s]
  !                    This must be given for each charge state and time
  !     par_loss_rates real*8 (ir,nt)
  !                    Frequency for parallel loss on radial and time grids [1/s]
  !     src_core     real*8 (ir,nt)
  !                    Radial source profile of externally injected neutrals neutrals over time [1/cm^3]
  !     rcl_rad_prof real*8 (ir, nt)
  !                    Normalized radial distribution of impurities re-entering the plasma after recycling
  !                    (or prompt recycling, if the full PWI model is used) over time.
  !     rfl_rad_prof real*8 (ir, nt)
  !                    Normalized radial distribution of impurities re-entering the plasma after reflection
  !                    (if the full PWI model is used) over time.
  !     spt_rad_prof real*8 (ir, 1+species, nt)
  !                    Normalized radial distribution of impurities re-entering the plasma after sputtering
  !                    (if the full PWI model is used) over time.
  !     en_rec_neut  logical
  !                    Logic key for setting energetic reflected/sputtered neutrals 
  !     S_rates      real*8 (ir,nion,nt)
  !                    Ionisation rates (nz=nion must be filled with zeros). Units of [1/s].
  !     R_rates      real*8 (ir,nion,nt)
  !                    Recombination rates (nz=nion must be filled with zeros). Units of [1/s].
  !     Raxis        real*8
  !                    Major radius at the magnetic axis [cm]
  !     rr           real*8 (ir)
  !                    Radial grid, defined using normalized flux surface volumes [cm]
  !     pro          real*8 (ir)
  !                    Normalized first derivative of the radial grid, defined by
  !                    pro = (drho/dr)/(2 d_rho) = rho'/(2 d_rho)
  !     qpr          real*8 (ir)
  !                    Normalized second derivative of the radial grid, defined as
  !                    qpr = (d^2 rho/dr^2)/(2 d_rho) = rho''/(2 d_rho)
  !     r_saw        real*8
  !                    Sawteeth inversion radius [cm]
  !     dlen         real*8
  !                    Decay length at last radial grid point
  !     time         real*8 (nt)
  !                    Time grid for transport solver
  !     saw          integer (nt)
  !                    Switch to induce a sawtooth crashes
  !                    If saw(it) eq 1 there is a crash at time(it)
  !     it_out       integer (nt)
  !                    Store the impurity distributions if it_out(it).eq.1
  !     dsaw         real*8
  !                    Width of sawtooth crash region.
  !     rcl          real*8
  !                    Wall recycling coefficient. Normally, this would be in the range [0,1].
  !                    However, if set to a value <0, then this is interpreted as a flag, indicating
  !                    that particles in the divertor should NEVER return to the main plasma.
  !                    This is effectively what the rclswitch flag does in STRAHL (confusingly).
  !     screen       real*8
  !                    screening efficiency for the backflow from the divertor reservoir, i.e. fraction
  !                    of rclb_rate which is screened in the SOL/divertor plasma and, therefore, gets
  !                    to be a part of the parallel flow dsu before even re-entering the main plasma
  !     rcmb         real*8
  !                    fraction the impurity ion flow in the SOL which recombines before reaching
  !                    the divertor target, i.e. which enters the divertor neutrals reservoir
  !                    bypassing the divertor wall reservoir.
  !     taudiv       real*8
  !                    Time scale for transport out of the divertor reservoir [s]
  !     taupump      real*8
  !                    Time scale for impurity elimination through out-pumping [s]
  !     tauwret      real*8
  !                    Time scale of temporary retention at the wall [s]
  !     S_pump       real*8
  !                    Pumping speed from the final particle reservoir (divertor or pump chamber) [cm^3/s]
  !     voldiv       real*8
  !                    Volume of the divertor reservoir [cm^3]
  !     cond         real*8
  !                    Conductance between divertor and pump reservoirs [cm^3/s]
  !     volpump      real*8
  !                    Volume of the pumping reservoir [cm^3]
  !     leak         real*8
  !                    Leakage conductance between pump reservoir and main chamber [cm^3/s]
  !     surfmain     real*8
  !                    Effective main wall surface area [cm^2]
  !     surfdiv      real*8
  !                    Effective divertor wall surface area [cm^2] 
  !     PWI          logical
  !                    Logic key for selecting which PWI model to use
  !     Zmain        integer
  !                    Atomic number of the main wall material
  !     Zdiv         integer
  !                    Atomic number of the divertor wall material 
  !     rnmain       real*8 (nt)
  !                    Reflection coefficients for the simulated impurity at the main wall on the time grid
  !     rndiv        real*8 (nt)
  !                    Reflection coefficients for the simulated impurity at the divertor wall on the time grid
  !     fluxmain     real*8 (species,nt)
  !                    Fluxes for each background species onto the main wall on the time grid [s^-1]
  !     fluxdiv      real*8 (species,nt)
  !                    Fluxes for each background species onto the divertor wall on the time grid [s^-1]
  !     ymain        real*8 (1+species,nt)
  !                    Normalized sputtering yields from simulated impurity + background species from the main wall on the time grid
  !     ydiv         real*8 (1+species,nt)
  !                    Normalized sputtering yields from simulated impurity + background species from the divertor wall on the time grid
  !     depthmain    real*8
  !                    Considered impurity implantation depth in the main wall [A]
  !     depthdiv     real*8
  !                    Considered impurity implantation depth in the divertor wall [A]
  !     nmainsat     real*8
  !                    Considered saturation value of the impurity implantation density into the main wall [m^-2]
  !     ndivsat      real*8
  !                    Considered saturation value of the impurity implantation density into the divertor wall [m^-2]  
  !     rvol_lcfs    real*8
  !                    Radius (in rvol units, cm) at which the LCFS is located
  !     dbound       real*8
  !                    Width of the SOL, given by r_bound - r_lcfs (in rvol coordinates, cm)
  !                    This value sets the width of the radial grid.
  !     dlim         real*8
  !                    Position of the limiter wrt to the LCFS, i.e. r_lim - r_lcfs (cm, in r_vol units).
  !                    Inside of this limiter location, the parallel connection length to the divertor applies,
  !                    while outside of it the relevant connection length is the one to the limiter.
  !                    These different connection lengths must be taken into consideration when
  !                    preparing the parallel loss rate variable.
  !     prox         real*8
  !                    Grid parameter for loss rate at the last radial point, returned by
  !                    `get_radial_grid' subroutine.
  !
  !
  !     OPTIONAL ARGUMENTS
  !
  !     rn_t0        real*8 (ir,nion), optional
  !                    Impurity densities at the start time [1/cm^3].
  !                    If not provided, all elements are set to 0.
  !     ndiv_t0      real*8, optional
  !                    Impurity density in the divertor reservoir at the start time [1/cm].
  !                    If not provided, this is set to 0.
  !     npump_t0     real*8, optional
  !                    Impurity density in the pump reservoir at the start time [1/cm].
  !                    If not provided, this is set to 0.
  !     nmainwall_t0 real*8, optional
  !                    Impurity density retained at the main wall at the start time [1/cm].
  !                    If not provided, this is set to 0.
  !     ndivwall_t0  real*8, optional
  !                    Impurity density retained at the divertor wall at the start time [1/cm].
  !                    If not provided, this is set to 0.
  !     alg_opt      integer, optional
  !                    Integer to indicate algorithm to be used.
  !                    If set to 0, use the finite-differences algorithm used in the 2018 version of STRAHL.
  !                    If set to 1, use the Linder finite-volume algorithm (see Linder et al. NF 2020)
  !     evolneut     logical, optional  
  !                    Boolean to activate evolution of neutrals (like any ionization stage).
  !                    The D and v given for the 0th charge state apply to these neutrals.
  !     src_div   real*8 (nt), optional
  !                  Flux of particles going into the divertor, given as a function of time in units
  !                  of [1/cm/s]. These particles will only affect the simulation if rcl>=0.
  !                  If not provided, src_div is automatically set to an array of zeros.
  !  
  ! Returns:
  !
  !     rn_out         eal*8 (ir,nion,nt_out)
  !                      Impurity densities (temporarily) in the magnetically-confined plasma at the
  !                      requested times [1/cm^3].
  !     N_mainwall     real*8 (nt_out)
  !                      Impurity densities (permanently) at the main wall over time [1/cm].
  !     N_divwall      real*8 (nt_out)
  !                      Impurity densities (permanently) at the divertor wall over time [1/cm].
  !     N_div          real*8 (nt_out)
  !                      Impurity densities (temporarily) in the divertor reservoir over time [1/cm].
  !     N_pump         real*8 (nt_out)
  !                      Impurity densities (temporarily) in the pump reservoir (if present) over time [1/cm].
  !     N_out          real*8 (nt_out)
  !                      Impurity densities (permanently) removed through the pump [1/cm].
  !     N_mainret      real*8 (nt_out)
  !                      Impurity densities (temporarily) retained at the main wall over time [1/cm].
  !     N_divret       real*8 (nt_out)
  !                      Impurity densities (temporarily) retained at the divertor wall over time [1/cm].
  !     N_tsu          real*8 (nt_out)
  !                      Edge loss [1/cm/s].
  !     N_dsu          real*8 (nt_out)
  !                      Parallel loss [1/cm/s].
  !     N_dsul         real*8 (nt_out)
  !                      Parallel loss to limiter [1/cm/s].
  !     rcld_rate      real*8 (nt_out)
  !                      Total recycling flux from divertor wall [1/cm/s].
  !     rcld_refl_rate real*8 (nt_out)
  !                      Reflected flux from divertor wall [1/cm/s].
  !     rcld_recl_rate real*8 (nt_out)
  !                      Promptly recycled flux from divertor wall [1/cm/s].
  !     rcld_impl_rate real*8 (nt_out)
  !                      Implanted flux into divertor wall [1/cm/s].
  !     rcld_sput_rate real*8 (1+species,nt_out)
  !                      Sputtered fluxes from divertor wall, per each sputtering species [1/cm/s].
  !     rclb_rate      real*8 (nt_out)
  !                      Backflow from divertor neutrals reservoir towards the plasma [1/cm/s].
  !     rcls_rate      real*8 (nt_out)
  !                      Backflow from divertor neutrals reservoir which is screened from the plasma  [1/cm/s].
  !     rclp_rate      real*8 (nt_out)
  !                      Leakage from pump neutrals reservoir (if present) towards the plasma [1/cm/s].
  !     rclw_rate      real*8 (nt_out)
  !                      Total recycling flux from main wall [1/cm/s].
  !     rclw_refl_rate real*8 (nt_out)
  !                      Reflected flux from main wall [1/cm/s].
  !     rclw_recl_rate real*8 (nt_out)
  !                      Promptly recycled flux from main wall [1/cm/s].
  !     rclw_impl_rate real*8 (nt_out)
  !                      Implanted flux into main wall [1/cm/s].
  !     rclw_sput_rate real*8 (1+species,nt_out)
  !                      Sputtered fluxes from main wall, per each sputtering species [1/cm/s].
  ! ---------------------------------------------------------------------------
  
  IMPLICIT NONE

  INTEGER, INTENT(IN)                  :: nion
  INTEGER, INTENT(IN)                  :: ir
  INTEGER, INTENT(IN)                  :: nt
  INTEGER, INTENT(IN)                  :: species
  INTEGER, INTENT(IN)                  :: nt_out   ! required as input
  INTEGER, INTENT(IN)                  :: nt_trans

  REAL*8, INTENT(IN)                   :: t_trans(nt_trans)
  REAL*8, INTENT(IN)                   :: D(ir,nt_trans,nion)
  REAL*8, INTENT(IN)                   :: V(ir,nt_trans,nion)
  REAL*8, INTENT(IN)                   :: par_loss_rates(ir,nt)
  REAL*8, INTENT(IN)                   :: src_core(ir,nt)
  REAL*8, INTENT(IN)                   :: rcl_rad_prof(ir,nt)  
  REAL*8, INTENT(IN)                   :: rfl_rad_prof(ir,nt)
  REAL*8, INTENT(IN)                   :: spt_rad_prof(ir,1+species,nt) 
  LOGICAL, INTENT(IN)                  :: en_rec_neut

  REAL*8, INTENT(IN)                   :: S_rates(ir,nion,nt)
  REAL*8, INTENT(IN)                   :: R_rates(ir,nion,nt)

  REAL*8, INTENT(IN)                   :: Raxis
  REAL*8, INTENT(IN)                   :: rr(ir)
  REAL*8, INTENT(IN)                   :: pro(ir)
  REAL*8, INTENT(IN)                   :: qpr(ir)

  REAL*8, INTENT(IN)                   :: r_saw
  REAL*8, INTENT(IN)                   :: dlen

  REAL*8, INTENT(IN)                   :: time(nt)
!!!  REAL*8, INTENT(IN)                   :: time_out(nt_out)

  INTEGER, INTENT(IN)                  :: saw(nt)
  INTEGER, INTENT(IN)                  :: it_out(nt)   !!!

  REAL*8, INTENT(IN)                   :: dsaw

  ! recycling and pumping inputs
  REAL*8, INTENT(IN)                   :: rcl
  REAL*8, INTENT(IN)                   :: screen
  REAL*8, INTENT(IN)                   :: rcmb
  REAL*8, INTENT(IN)                   :: taudiv
  REAL*8, INTENT(IN)                   :: taupump
  REAL*8, INTENT(IN)                   :: tauwret
  REAL*8, INTENT(IN)                   :: S_pump
  REAL*8, INTENT(IN)                   :: voldiv
  REAL*8, INTENT(IN)                   :: cond
  REAL*8, INTENT(IN)                   :: volpump
  REAL*8, INTENT(IN)                   :: leak
  
  ! plasma-wall interaction inputs
  REAL*8, INTENT(IN)                   :: surfmain
  REAL*8, INTENT(IN)                   :: surfdiv
  LOGICAL, INTENT(IN)                  :: PWI
  INTEGER, INTENT(IN)                  :: Zmain
  INTEGER, INTENT(IN)                  :: Zdiv
  REAL*8, INTENT(IN)                   :: rnmain(nt)
  REAL*8, INTENT(IN)                   :: rndiv(nt)
  REAL*8, INTENT(IN)                   :: fluxmain(species,nt)
  REAL*8, INTENT(IN)                   :: fluxdiv(species,nt)
  REAL*8, INTENT(IN)                   :: ymain(1+species,nt)
  REAL*8, INTENT(IN)                   :: ydiv(1+species,nt)
  REAL*8, INTENT(IN)                   :: depthmain
  REAL*8, INTENT(IN)                   :: depthdiv
  REAL*8, INTENT(IN)                   :: nmainsat
  REAL*8, INTENT(IN)                   :: ndivsat

  ! edge
  REAL*8, INTENT(IN)                   :: rvol_lcfs
  REAL*8, INTENT(IN)                   :: dbound
  REAL*8, INTENT(IN)                   :: dlim
  REAL*8, INTENT(IN)                   :: prox

  ! optional arguments
  REAL*8, INTENT(IN), OPTIONAL         :: rn_t0(ir,nion)
  REAL*8, INTENT(IN), OPTIONAL         :: ndiv_t0
  REAL*8, INTENT(IN), OPTIONAL         :: npump_t0
  REAL*8, INTENT(IN), OPTIONAL         :: nmainwall_t0
  REAL*8, INTENT(IN), OPTIONAL         :: ndivwall_t0
  INTEGER, INTENT(IN), OPTIONAL        :: alg_opt
  LOGICAL, INTENT(IN), OPTIONAL        :: evolneut
  REAL*8, INTENT(IN), OPTIONAL         :: src_div(nt)
  
  ! outputs
  REAL*8, INTENT(OUT)                  :: rn_out(ir,nion,nt_out)

  REAL*8, INTENT(OUT)                  :: N_mainwall(nt_out) ! particles stuck permanently at the main wall
  REAL*8, INTENT(OUT)                  :: N_divwall(nt_out)  ! particles stuck permanently at the divertor wall
  REAL*8, INTENT(OUT)                  :: N_div(nt_out)      ! particles in the divertor reservoir
  REAL*8, INTENT(OUT)                  :: N_pump(nt_out)     ! particles in the pump reservoir
  REAL*8, INTENT(OUT)                  :: N_out(nt_out)      ! particles removed through the pump
  REAL*8, INTENT(OUT)                  :: N_mainret(nt_out)  ! particles retained temporarily at the main wall
  REAL*8, INTENT(OUT)                  :: N_divret(nt_out)   ! particles retained temporarily at the divertor wall

  REAL*8, INTENT(OUT)                  :: N_tsu(nt_out)   ! particles lost at the edge
  REAL*8, INTENT(OUT)                  :: N_dsu(nt_out)   ! parallel loss to divertor
  REAL*8, INTENT(OUT)                  :: N_dsul(nt_out)  ! parallel loss to limiter

  REAL*8, INTENT(OUT)                  :: rcld_rate(nt_out)          ! total recycling flux from divertor wall
  REAL*8, INTENT(OUT)                  :: rcld_refl_rate(nt_out)     ! reflected flux from divertor wall
  REAL*8, INTENT(OUT)                  :: rcld_recl_rate(nt_out)     ! promptly recycled flux from divertor wall
  REAL*8, INTENT(OUT)                  :: rcld_impl_rate(nt_out)     ! implanted flux into divertor wall
  REAL*8, INTENT(OUT)                  :: rcld_sput_rate(1+species,nt_out) ! sputtered fluxes from divertor wall
  REAL*8, INTENT(OUT)                  :: rclb_rate(nt_out)          ! non-screened backflow from divertor neutrals reservoir
  REAL*8, INTENT(OUT)                  :: rcls_rate(nt_out)          ! screened backflow from divertor neutrals reservoir
  REAL*8, INTENT(OUT)                  :: rclp_rate(nt_out)          ! leakage from pump neutrals reservoir
  REAL*8, INTENT(OUT)                  :: rclw_rate(nt_out)          ! total recycling flux from main wall
  REAL*8, INTENT(OUT)                  :: rclw_refl_rate(nt_out)     ! reflected flux from main wall
  REAL*8, INTENT(OUT)                  :: rclw_recl_rate(nt_out)     ! promptly recycled flux from main wall
  REAL*8, INTENT(OUT)                  :: rclw_impl_rate(nt_out)     ! implanted flux into main wall
  REAL*8, INTENT(OUT)                  :: rclw_sput_rate(1+species,nt_out) ! sputtered fluxes from main wall
  
  INTEGER     :: i, it, kt, nz, s
  REAL*8      :: rn(ir,nion), ra(ir,nion), dt
  REAL*8      :: Nmainret, Ndivret, Nmainwall, Ndivwall, divnew, pumpnew, nout, divold, pumpold
  REAL*8      :: diff(ir, nion), conv(ir, nion)
  REAL*8      :: tsu, dsu, dsul
  REAL*8      :: rcld, rcld_refl, rcld_recl, div_flux_impl, div_fluxes_sput(1+species)
  REAL*8      :: rclb, rcls, rclp
  REAL*8      :: rclw, rclw_refl, rclw_recl, main_flux_impl, main_fluxes_sput(1+species)
  REAL*8      :: rn_t0_in(ir,nion) ! used to support optional argument rn_t0
  REAL*8      :: ndiv_t0_in ! used to support optional argument ndiv_t0
  REAL*8      :: npump_t0_in ! used to support optional argument npump_t0
  REAL*8      :: nmainwall_t0_in ! used to support optional argument nmainwall_t0
  REAL*8      :: ndivwall_t0_in ! used to support optional argument ndivwall_t0
  REAL*8      :: src_div_in(nt) ! used to support optional argument src_div
  INTEGER     :: sel_alg_opt
  
  ! Only used in impden (define here to avoid re-allocating memory at each impden call)
  REAL*8 :: a(ir,nion), b(ir,nion), c(ir,nion), d1(ir), bet(ir), gam(ir)

  LOGICAL :: evolveneut

  ! rn_t0 is an optional argument. if user does not provide it, set all array elements to 0
  if(present(rn_t0))then
     rn_t0_in=rn_t0
  else
     rn_t0_in=0.0d0 ! all elements set to 0
  endif
  
  ! Initial conditions at the resrvoirs ndiv_t0, npump_t0, nmainwall_t0, ndivwall_t0
  ! are optional arguments. if user does not provide them, set them to 0
  if(present(ndiv_t0))then
     ndiv_t0_in=ndiv_t0
  else
     ndiv_t0_in=0.0d0
  endif
  if(present(npump_t0))then
     npump_t0_in=npump_t0
  else
     npump_t0_in=0.0d0
  endif
  if(present(nmainwall_t0))then
     nmainwall_t0_in=nmainwall_t0
  else
     nmainwall_t0_in=0.0d0
  endif
  if(present(ndivwall_t0))then
     ndivwall_t0_in=ndivwall_t0
  else
     ndivwall_t0_in=0.0d0
  endif
  
  if(present(alg_opt))then
     sel_alg_opt=alg_opt
  else
     sel_alg_opt=1 ! use Linder algorithm by default
  endif

  if(present(evolneut))then
     evolveneut=evolneut
  else
     evolveneut=.false.
  endif

  if (present(src_div))then
     src_div_in = src_div
  else
     src_div_in = 0.0d0 ! all elements set to 0
  endif

  ! Set start densities in the plasma
  rn = rn_t0_in  ! all ir, nion points
  
  ! Set start contents in the dynamic reservoirs
  divnew = ndiv_t0_in
  pumpnew = npump_t0_in
  Nmainret = nmainwall_t0_in
  Ndivret = ndivwall_t0_in
  
  ! Initialize permanent reservoirs
  Nmainwall = 0.d0
  Ndivwall = 0.d0
  nout = 0.d0
  
  ! Initialize fluxes
  tsu = 0.0d0
  dsu = 0.0d0
  dsul = 0.0d0

  ! Set starting values in final output arrays
  it = 1
  kt = 1
  if (it_out(it) == 1) then
     !if ( ANY( time_out==time(it) ) ) then

     rn_out(:,:,kt) = rn ! all nion,ir for the first time point
     N_mainwall(kt) = Nmainwall
     N_divwall(kt) = Ndivwall
     N_div(kt) = divnew
     N_pump(kt) = pumpnew
     N_out(kt) = nout
     N_tsu(kt) = tsu
     N_dsu(kt) = dsu
     N_dsul(kt) = dsul

     N_mainret(kt) = Nmainret
     N_divret(kt) = Ndivret
     rcld_rate(kt) = 0.d0
     rcld_refl_rate(kt) = 0.d0
     rcld_recl_rate(kt) = 0.d0
     rcld_impl_rate(kt) = 0.d0
     do s = 1,1+species
        rcld_sput_rate(s,kt) = 0.d0
     end do
     rclb_rate(kt) = 0.d0
     rcls_rate(kt) = 0.d0
     rclp_rate(kt) = 0.d0
     rclw_rate(kt) = 0.d0
     rclw_refl_rate(kt) = 0.d0
     rclw_recl_rate(kt) = 0.d0
     rclw_impl_rate(kt) = 0.d0
     do s = 1,1+species
        rclw_sput_rate(s,kt) = 0.d0
     end do

     kt = kt+1
  end if


  ! ======== time loop: ========
  do it=2,nt
     dt = time(it)-time(it-1)

     ra = rn ! Update old array to new (from previous time step)

     do nz=1,nion
        ! Updated transport coefficients for each charge state
        call linip_arr(nt_trans, ir, t_trans, D(:,:,nz), time(it), diff(:, nz))
        call linip_arr(nt_trans, ir, t_trans, V(:,:,nz), time(it), conv(:,nz))
     end do
     divold = divnew 
     pumpold = pumpnew

     ! Evolve impurity density in the plasma with current transport coefficients
     ! and reservoirs contents according to the imposed recycling parameters
     
     if (sel_alg_opt.eq.0) then
        ! Use old algorithm, just for benchmarking
        call impden0(nion, ir, species, ra, rn,  &   ! IN: old impurity density, OUT: new impurity density
             diff, conv, & 
             par_loss_rates(:,it), &   ! Parallel loss rates for the current time step
             src_core(:,it), &   ! Radial source profile for the current time step
             rcl_rad_prof(:,it), rfl_rad_prof(:,it), spt_rad_prof(:,:,it), en_rec_neut, &   ! Radial recycling profiles for the current time step
             S_rates(:,:,it), R_rates(:,:,it), &   ! Ioniz. and recomb. rates for the current time step
             Raxis, rr, pro, qpr, dlen, &   ! Radial grid parameters
             dt, &   ! full time step
             surfmain, surfdiv, PWI, Zmain, Zdiv, &   ! PWI parameters - surfaces characteristics
             rnmain(it), rndiv(it), &   ! PWI parameters - reflection coeffs. for the current time step
             fluxmain(:,it), fluxdiv(:,it), ymain(:,it), ydiv(:,it), &   ! PWI parameters - background fluxes and sputt. yeilds for the current time step
             depthmain, depthdiv, nmainsat, ndivsat, &   ! PWI parameters - implantation parameters
             rcl, screen, rcmb, &   ! edge parameters
             tsu, dsu, dsul, divold, pumpold, &   ! fluxes and neutrals reservoirs content from previous time step
             taudiv, tauwret, leak, volpump, &   ! pumping parameters
             a, b, c, d1, bet, gam, &   ! re-use memory allocation
             Nmainret, Ndivret, &   ! INOUT: Dynamic wall reservoirs content
             rcld, rcld_refl, rcld_recl, div_flux_impl, div_fluxes_sput(:), &   ! OUT: divertor wall wall recycling fluxes
             rclb, rcls, rclp, &   ! OUT: divertor backflow related fluxes
             rclw, rclw_refl, rclw_recl, main_flux_impl, main_fluxes_sput(:))   ! OUT: main wall recycling fluxes
        
     else
        ! Currently use Linder algorithm for any option other than 0
        call impden1(nion, ir, species, ra, rn,&   ! IN: old impurity density, OUT: new impurity density
             diff, conv, &
             par_loss_rates(:,it), &   ! Parallel loss rates for the current time step
             src_core(:,it), &   ! Radial source profile for the current time step
             rcl_rad_prof(:,it), rfl_rad_prof(:,it), spt_rad_prof(:,:,it), en_rec_neut, &   ! Radial recycling profiles for the current time step
             S_rates(:,:,it), R_rates(:,:,it), &   ! Ioniz. and recomb. rates for the current time step
             Raxis, rr, dlen, &   ! Radial grid parameters
             dt, &   ! renaming dt-->det. In this subroutine, dt is half-step
             surfmain, surfdiv, PWI, Zmain, Zdiv, &   ! PWI parameters - surfaces characteristics
             rnmain(it), rndiv(it), &   ! PWI parameters - reflection coeffs. for the current time step
             fluxmain(:,it), fluxdiv(:,it), ymain(:,it), ydiv(:,it), &   ! PWI parameters - background fluxes and sputt. yeilds for the current time step
             depthmain, depthdiv, nmainsat, ndivsat, &   ! PWI parameters - implantation parameters
             rcl, screen, rcmb, &    ! edge parameters
             tsu, dsu, dsul, divold, pumpold, &    ! fluxes and neutrals reservoirs content from previous time step
             taudiv, tauwret, leak, volpump, &   ! pumping parameters
             evolveneut, &  
             Nmainret, Ndivret, &   ! INOUT: Dynamic wall reservoirs content
             rcld, rcld_refl, rcld_recl, div_flux_impl, div_fluxes_sput(:), &   ! OUT: divertor wall wall recycling fluxes
             rclb, rcls, rclp, &   ! OUT: divertor backflow related fluxes
             rclw, rclw_refl, rclw_recl, main_flux_impl, main_fluxes_sput(:))   ! OUT: main wall recycling fluxes
       
     endif
     
     ! sawteeth
     if (saw(it) == 1) then
        CALL saw_mix(nion, ir, rn, r_saw, dsaw, rr, pro)
     end if

     ! Particle losses towards walls/divertor + Particles permanently absorbed by the walls + Evolution of neutrals reservoirs
     CALL edge_model(nion, ir, ra, rn,  &
          diff, conv, par_loss_rates(:,it), dt, rvol_lcfs, &    ! dt is the full type step here
          dbound, dlim, prox, &
          rr, pro,  &
          PWI, rcl, rcmb, taudiv, taupump, &
          S_pump, voldiv, cond, volpump, leak, &
          src_div_in(it), rcld, rcls, divold, pumpold, &
          divnew, pumpnew, &              ! OUT: update to divold and pumpold
          Nmainwall, Ndivwall, nout, &    ! INOUT: updated values
          tsu, dsu, dsul)                 ! OUT: updated by edge model


     ! Array time-step saving/output
     if (it_out(it) == 1) then
     !if ( ANY( time_out==time(it) ) ) then
        do nz=1,nion
           do i=1,ir
              rn_out(i,nz,kt) = rn(i,nz)
           end do
        end do

        N_mainwall(kt) = Nmainwall
        N_divwall(kt) = Ndivwall
        N_div(kt) = divnew
        N_pump(kt) = pumpnew
        N_out(kt) = nout
        N_tsu(kt) = tsu
        N_dsu(kt) = dsu
        N_dsul(kt) = dsul

        N_mainret(kt) = Nmainret
        N_divret(kt) = Ndivret
        rcld_rate(kt) = rcld
        rcld_refl_rate(kt) = rcld_refl
        rcld_recl_rate(kt) = rcld_recl
        rcld_impl_rate(kt) = div_flux_impl
        do s = 1,1+species
            rcld_sput_rate(s,kt) = div_fluxes_sput(s)
        end do
        rclb_rate(kt) = rclb
        rcls_rate(kt) = rcls
        rclp_rate(kt) = rclp
        rclw_rate(kt) = rclw
        rclw_refl_rate(kt) = rclw_refl
        rclw_recl_rate(kt) = rclw_recl
        rclw_impl_rate(kt) = main_flux_impl
        do s = 1,1+species
            rclw_sput_rate(s,kt) = main_fluxes_sput(s)
        end do

        kt = kt+1
     end if

  end do
  ! ====== end of time loop ========

  return

end subroutine run







subroutine saw_mix(nion, ir, rn, rsaw, dsaw, rr, pro)

  IMPLICIT NONE

  INTEGER, INTENT(IN)                      :: nion
  INTEGER, INTENT(IN)                      :: ir
  REAL*8, INTENT(INOUT)                 :: rn(ir,nion)
  REAL*8, INTENT(IN)                       :: rsaw
  REAL*8, INTENT(IN)                       :: dsaw
  REAL*8, INTENT(IN)                       :: rr(ir)
  REAL*8, INTENT(IN)                       :: pro(ir)

  INTEGER :: i, nz, imix

  REAL*8 sum , sum_old, ff

  !     index of mixing radius
  imix=0
  do i=1,ir
     if (rr(i) > rsaw .and. imix == 0) then
        imix = i
     end if
  end do

  do nz=2,nion              !loop over ionized stages

     !     area integral in mixing radius of old profile

     sum_old =0.125*(rn(imix,nz)*rr(imix)/pro(imix)  &  ! only use new density, rn
          - rn(imix-1,nz)*rr(imix-1)/pro(imix-1))
     do i=2,imix-1
        sum_old = sum_old + rn(i,nz)*rr(i)/pro(i)
     end do

     !    ERFC sawtooth crash model
     ff = sum_old/rr(imix)**2  ! nmean
     do i=1, ir
        rn(i,nz) = ff/2. * erfc(( rr(i) - rsaw )/dsaw)+(rn(i,nz)/2.0 )*erfc(-(rr(i)-rsaw)/dsaw)
     end do

     !      flat profile
     !  ff = sum_old/rr(imix)**2
     !  do i=1,imix-1
     !    rn(i,nz) = ff
     !  end do
     !  rn(imix,nz) = (ra(imix+1,nz)+ff)/2.

     !      area integral in mixing radius of new profile

     sum =0.125*( rn(imix, nz)*rr(imix) /pro(imix) -  &
          rn(imix-1, nz)*rr(imix-1)/pro(imix-1))
     do i=2,imix-1
        sum = sum + rn(i,nz)*rr(i)/pro(i)
     end do

     !      ensure particle conservation

     ff = sum_old/sum
     do i=1,imix
        rn(i,nz) = rn(i,nz)*ff
     end do

  end do

  return

end subroutine saw_mix







subroutine edge_model( &
    nion, ir, ra, rn, &
    diff, conv, &
    par_loss_rate, det, rvol_lcfs, &
    dbound, dlim, prox, &
    rr, pro,  &
    PWI, rcl, rcmb, taudiv, taupump, &
    S_pump, voldiv, cond, volpump, leak, &
    src_div_t, rcld, rcls, divold, pumpold, &
    divnew, pumpnew, Nmainwall, Ndivwall, nout, tsu, dsu, dsul)

  IMPLICIT NONE

  INTEGER, INTENT(IN)                   :: nion
  INTEGER, INTENT(IN)                   :: ir
  REAL*8, INTENT(INOUT)                 :: ra(ir,nion)
  REAL*8, INTENT(INOUT)                 :: rn(ir,nion)

  REAL*8, INTENT(IN)                    :: diff(ir, nion)
  REAL*8, INTENT(IN)                    :: conv(ir, nion)

  REAL*8, INTENT(IN)                    :: par_loss_rate(ir)
  REAL*8, INTENT(IN)                    :: det   ! full time step
  REAL*8, INTENT(IN)                    :: rvol_lcfs 
  REAL*8, INTENT(IN)                    :: dbound
  REAL*8, INTENT(IN)                    :: dlim
  REAL*8, INTENT(IN)                    :: prox  ! for edge loss calculation

  REAL*8, INTENT(IN)                    :: rr(ir)
  REAL*8, INTENT(IN)                    :: pro(ir)

  LOGICAL, INTENT(IN)                   :: PWI       ! select which PWI model to use
  REAL*8, INTENT(IN)                    :: rcl       ! main/divertor walls recycling coefficient
  REAL*8, INTENT(IN)                    :: rcmb      ! recombination ratio of divertor plasma
  REAL*8, INTENT(IN)                    :: taudiv    ! time scale for divertor retention
  REAL*8, INTENT(IN)                    :: taupump   ! time scale for pumping
  
  REAL*8, INTENT(IN)                    :: S_pump    ! pumping speed
  REAL*8, INTENT(IN)                    :: voldiv    ! divertor volume
  REAL*8, INTENT(IN)                    :: cond      ! divertor-pump conductance
  REAL*8, INTENT(IN)                    :: volpump   ! pump volume
  REAL*8, INTENT(IN)                    :: leak      ! leaking conductance from pump towards main chamber

  REAL*8, INTENT(IN)                    :: src_div_t ! injected flux into the div. reservoir
  REAL*8, INTENT(IN)                    :: rcld      ! recycling flux from the div. wall into the div. reservoir
  REAL*8, INTENT(IN)                    :: rcls      ! portion of backflow from divertor which is screened
  REAL*8, INTENT(IN)                    :: divold    ! particles initially in the div. reservoir (to update)
  REAL*8, INTENT(IN)                    :: pumpold   ! particles initially in the pump reservoir (to update)

  REAL*8, INTENT(OUT)                   :: divnew    ! particles in the div. reservoir (updated)
  REAL*8, INTENT(OUT)                   :: pumpnew   ! particles in the pump reservoir (updated)
  REAL*8, INTENT(INOUT)                 :: Nmainwall ! particles stuck at main wall (updated)
  REAL*8, INTENT(INOUT)                 :: Ndivwall  ! particles stuck at divertor wall (updated)
  REAL*8, INTENT(INOUT)                 :: nout      ! particles removed through the pump (updated)
  REAL*8, INTENT(OUT)                   :: tsu       ! edge loss
  REAL*8, INTENT(OUT)                   :: dsu       ! parallel loss
  REAL*8, INTENT(OUT)                   :: dsul      ! parallel loss to limiter

  INTEGER :: i, nz, ids, idl, ids1, idl1
  REAL*8 :: rx, pi, taustar_div, taustar_pump, taucond_eff_back, taucond_eff_forw, tauleak, taupump_eff, ff_div, ff_pump

  ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Compute edge fluxes given multi-reservoir parameters
  ! Core-densities do not directly depend on this -- but recycling
  ! can only be activated if this 1D edge model is included.
  ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pi = 4. * atan(1.)
  rx=rvol_lcfs+dbound   ! wall (final) location

  ! ---------------------------------------------

  do i=2,ir
     if(rr(i) .le. rvol_lcfs) ids=i+1   ! number of radial points inside of LCFS
     if(rr(i) .le. (rvol_lcfs+dlim)) idl=i+1     ! number of radial points inside of limiter
  end do
  ids1=ids-1
  idl1 = idl-1 

  ! --------------------------------------
  
  ! Ions lost at the plasma periphery (radial edge loss) / seconds
  tsu=0.d0
  do nz=2,nion
     tsu=tsu - prox * (diff(ir-1,nz)+diff(ir,nz)) * (rn(ir,nz)+ra(ir,nz) - rn(ir-1,nz)-ra(ir-1,nz))  + &
          .5*(conv(ir-1,nz)+conv(ir,nz)) *(  rn(ir,nz)+ra(ir,nz)+ rn(ir-1,nz)+ra(ir-1,nz) )
  end do
  tsu=tsu*.5*pi*rx

  !  Parallel ion loss in the SOL (towards divertor) / seconds
  dsu=0.d0
  do nz=2,nion
     do i=ids,idl1
        dsu=dsu+(ra(i,nz)+rn(i,nz)) *par_loss_rate(i)*rr(i)/pro(i)
     end do
  end do
  dsu = dsu*pi/2.

  !  Parallel ion loss in the SOL (towards limiter) / seconds
  dsul=0.d0
  do nz=2,nion
     do i=idl,ir-1
        dsul=dsul+(ra(i,nz)+rn(i,nz)) *par_loss_rate(i)*rr(i)/pro(i)
     end do
  end do
  dsul = dsul*pi/2.

  ! Permanent particle losses at the walls
  
  ! Full plasma-wall interaction model activated: permanent wall reservoir not used
  if (PWI) then
  
     Nmainwall = Nmainwall  ! permanent main wall reservoir always empty
     Ndivwall = Ndivwall  ! permanent divertor wall reservoir always empty
  
  ! Simple plasma-wall interaction model activated: permanent wall reservoir used
  else
  
     if (rcl.ge.0) then
        Nmainwall = Nmainwall + (dsul + tsu) * (1.-rcl)*det      ! rcl=0 or rcl>0, but always w/ divertor return
        Ndivwall = Ndivwall + (dsu+rcls) * (1.-rcmb) * (1.-rcl)*det   ! rcl=0 or rcl>0, but always w/ divertor return
     else
        Nmainwall = Nmainwall + (dsul + tsu) * det      ! no recycling, no divertor return
        Ndivwall = Ndivwall + (dsu+rcls) * (1.-rcmb) * det   ! no recycling, no divertor return
     endif
  
  endif

  ! Evolution of particle content in divertor/pump reservoirs
  ! If recycling is on (rcl>0), a fraction of particles hitting the walls can come back
  ! Particles in divertor can only return to the plasma (with rate given by N_div/taudiv) if rcl>=0
  
  ! Activated divertor backflow (rcl>=0) + recycling mode (if rcl>0)
  if (rcl.ge.0) then
     
     ! Adimensional model (pumping done from the divertor and defined by a time taupump)
     if (voldiv.eq.0) then
        taustar_div = 1./(1./taudiv+1./taupump)  ! eff. time scale for divertor depletion
        ff_div = .5*det/taustar_div
        divnew = ( divold*(1.-ff_div) + ((dsu+rcls)*rcmb + rcld + src_div_t)*det )/(1.+ff_div)
        pumpnew = pumpold
    
     ! Physical volumes for the reservoirs
     else
        
        ! Pumping done from the divertor and defined by a speed S_pump
        if (volpump.eq.0) then
           taupump_eff = voldiv/S_pump
           taustar_div = 1./(1./taudiv+1./taupump_eff)  ! eff. time scale for divertor depletion
           ff_div = .5*det/taustar_div
           divnew = ( divold*(1.-ff_div) + ((dsu+rcls)*rcmb + rcld + src_div_t)*det )/(1.+ff_div)
           pumpnew = pumpold
        
        ! Pumping done from a secondary pump chamber via a conductance cond and defined by a speed S_pump
        else
           taupump_eff = volpump/S_pump
           taucond_eff_forw = voldiv/cond
           taucond_eff_back = volpump/cond
           taustar_div = 1./(1./taudiv+1./taucond_eff_forw)  ! eff. time scale for flow divertor --> pump
           ff_div = .5*det/taustar_div
           divnew = ( divold*(1.-ff_div) + ((dsu+rcls)*rcmb + rcld + src_div_t + (pumpold/taucond_eff_back))*det )/(1.+ff_div)
           if (leak.eq.0) then
              taustar_pump = 1./(1./taucond_eff_back+1./taupump_eff)  ! eff. time scale for pump depletion
           else
              tauleak = volpump/leak
              taustar_pump = 1./(1./taucond_eff_back+1./taupump_eff+1./tauleak)  ! eff. time scale for pump depletion
           endif
           ff_pump = .5*det/taustar_pump
           pumpnew = ( pumpold*(1.-ff_pump) + (divold/taucond_eff_forw)*det )/(1.+ff_pump)
        endif
     endif
  
  ! No backflow from the divertor (rcl<0), i.e. taudiv --> inf
  else
     
     ! Adimensional model (pumping done from the divertor and defined by a time taupump)
     if (voldiv.eq.0) then
        taustar_div = taupump  ! eff. time scale for divertor depletion
        ff_div = .5*det/taustar_div
        divnew = ( divold*(1.-ff_div) + ((dsu+rcls)*rcmb + rcld + src_div_t)*det )/(1.+ff_div)  
        pumpnew = pumpold
     
     ! Physical volumes for the reservoirs
     else
        
        ! Pumping done from the divertor and defined by a speed S_pump
        if (volpump.eq.0) then
           taupump_eff = voldiv/S_pump
           taustar_div = taupump_eff  ! eff. time scale for divertor depletion
           ff_div = .5*det/taustar_div
           divnew = ( divold*(1.-ff_div) + ((dsu+rcls)*rcmb + rcld + src_div_t)*det )/(1.+ff_div)
           pumpnew = pumpold
        
        ! Pumping done from a secondary pump chamber via a conductance cond and defined by a speed S_pump
        else
           taupump_eff = volpump/S_pump
           taucond_eff_forw = voldiv/cond
           taucond_eff_back = volpump/cond
           taustar_div = taucond_eff_forw  ! eff. time scale for flow divertor --> pump
           ff_div = .5*det/taustar_div
           divnew = ( divold*(1.-ff_div) + ((dsu+rcls)*rcmb + rcld + src_div_t + (pumpold/taucond_eff_back))*det )/(1.+ff_div)
           if (leak.eq.0) then
              taustar_pump = 1./(1./taucond_eff_back+1./taupump_eff)  ! eff. time scale for pump depletion
           else
              tauleak = volpump/leak
              taustar_pump = 1./(1./taucond_eff_back+1./taupump_eff+1./tauleak)  ! eff. time scale for pump depletion
           endif
           ff_pump = .5*det/taustar_pump
           pumpnew = ( pumpold*(1.-ff_pump) + (divold/taucond_eff_forw)*det )/(1.+ff_pump)
        
        endif
     
     endif
     
  endif
  
  ! Evolution of particles permanently pumped
  ! Adimensional model (pumping done from the divertor and defined by a time taupump)
  if (voldiv.eq.0) then
     nout = nout + .5*(divnew+divold)/taupump*det
  
  ! Physical volumes for the reservoirs
  else
  
     ! Pumping done from the divertor and defined by a speed S_pump
     if (volpump.eq.0) then
        nout = nout + .5*(divnew+divold)/taupump_eff*det
     
     ! Pumping done from a secondary pump chamber via a conductance cond and defined by a speed S_pump
     else
        nout = nout + .5*(pumpnew+pumpold)/taupump_eff*det   
     
     endif
  
  endif

  return

end subroutine edge_model
